<?php
/*
 * @component RewardPointsVm
 * @copyright Copyright (C) 2102 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardspoints.com
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );
jimport('joomla.plugin.plugin');

class rewardpointsvmModelUsers extends JModelLegacy {
	
   	var $_total = null;
   	var $_pagination = null;
		
		
	function __construct() {
		parent::__construct();
		
		$mainframe = JFactory::getApplication();
		// Get pagination request variables
		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JFactory::getApplication()->input->get('limitstart', 0, '', 'int');
		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}	
	
	// funzione per il sorting della tabella
	protected function populateState() {
		
		// Initialise variables.
		$app = JFactory::getApplication();

		$filter_order = JFactory::getApplication()->input->get('filter_order','virtuemart_user_id');
		$filter_order_Dir = JFactory::getApplication()->input->get('filter_order_Dir', 'ASC');
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_Dir', $filter_order_Dir);
		
		// Load the filter state.
		$search = $app->getUserStateFromRequest($this->state.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);
		/*$state = $app->getUserStateFromRequest($this->state.'.filter.state', 'filter_state', '', 'string');
		$this->setState('filter.state', $state);*/

	}

	
	// ---------------------------------------------------------------
	// RECUPERO DATI CON IMPAGINATORE 
	// ---------------------------------------------------------------
	function _buildQuery(){	
	
		$db = $this->getDbo();
		$query = $db->getQuery(true);
		
		// orderBy
		$query->order($db->escape($this->getState('filter_order')) . ' ' . $db->escape($this->getState('filter_order_Dir')));
		// search filter
		$search = $this->getState('filter.search');
		if (!empty($search)) { // se si esegue la ricerca
			$query->where("(referreid LIKE '%".$search."%') AND (referreid != 'pending_activation') ");
		} else {
			$query->where("(referreid != 'pending_activation') ");
		}
		
		// master query
		$query = "SELECT * FROM #__virtuemart_rewardspoints ".$query->where." ".$query->order;
		
		return $query;
	}
	
	
	
	
	
	function getTotal() {
		// Load the content if it doesn't already exist
		if (empty($this->_total)) {
		    $query = $this->_buildQuery();
		    $this->_total = $this->_getListCount($query);	
		}
		return $this->_total;
	}
	function getPagination() {
		// Load the content if it doesn't already exist
		
		if (empty($this->_pagination)) {
		    jimport('joomla.html.pagination');
		    $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	
	
	
	
	function getData() {
		// if data hasn't already been obtained, load it
		if (empty($this->_data)) {
		   	$query = $this->_buildQuery();
			// Add the list ordering clause.
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));	
		}
		// codice qui
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings();
		// -------------------------------------------------------------------------
		for($scan=0; $scan<count($this->_data); $scan++) {
			$this->_data[$scan]->newActivity = RewardHelper::getListActivity('all',$this->_data[$scan]->virtuemart_user_id);
			$this->_data[$scan]->newPoints = RewardHelper::getCurrentTotalPoints($this->_data[$scan]->referreid);
			
			/*
for($scanAct=0; $scanAct<count($this->_data[$scan]->newActivity); $scanAct++){
			// table field: coupon_value
				if($this->_data[$scan]->newActivity[$scanAct]['rule'] == "plgaup_vmalphapointstocash" ){
					$this->_data[$scan]->newActivity[$scanAct]['chipsColor'] = $config['chips_color'];
					if($config['chips_color_threshold2'] && abs($this->_data[$scan]->newActivity[$scanAct]['points']) >=$config['chips_color_threshold2']){
						$this->_data[$scan]->newActivity[$scanAct]['chipsColor'] = $config['chips_color2'];
					} 
					if($config['chips_color_threshold3'] && abs($this->_data[$scan]->newActivity[$scanAct]['points']) >=$config['chips_color_threshold3']){
						$this->_data[$scan]->newActivity[$scanAct]['chipsColor'] = $config['chips_color3'];
					}
					if($config['chips_color_threshold4'] && abs($this->_data[$scan]->newActivity[$scanAct]['points']) >=$config['chips_color_threshold4']){
						$this->_data[$scan]->newActivity[$scanAct]['chipsColor'] = $config['chips_color4'];
					}
				}
			}
*/
			
		}
		return $this->_data;
	 }
	 // ---------------------------------------------------------------
	 // ---------------------------------------------------------------
	 // ---------------------------------------------------------------
	 
	 
	 // questa funzione si utilizza con allChip on e riconverte la chip attuale in punti
	 // prima di eseguire il custom points da amministrazione
	 function reconvertChipBeforeModifying($referreid) {
	 	 	
	 	$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings();
		
		if($config['autochips_allchips'] == 1) { // esegue prima la riconversione punti
			$date = JFactory::getDate();
			$now  = $date->toSql();
			// mainframe awo coupons
			if($config['couponmanager']=="AWO") {
				$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';
				if ( file_exists($awocoupon)) require_once ($awocoupon);
			}
			$db = JFactory::getDBO();
			// coupon virtuemart
			if($config['couponmanager'] =="virtuemart") {
				$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__virtuemart_coupons WHERE #__virtuemart_rewardspoints_details.referreid='".$referreid."' ";
				$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
				$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
				$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
				$query .= "AND #__virtuemart_coupons.coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
				$query .= "AND #__virtuemart_coupons.published=1 ";
				$query .= "AND #__virtuemart_coupons.coupon_used='' ";
				$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
				$db->setQuery($query);
				$lastcoupons = $db->loadAssocList();
			}
			// coupon awo
			if($config['couponmanager'] =="awo") {
				$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__".AWOCOUPON." WHERE #__virtuemart_rewardspoints_details.referreid='".$referreid."' ";
				$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
				$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
				$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
				$query .= "AND #__".AWOCOUPON.".coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
				$query .= "AND #__".AWOCOUPON.".published=1 ";
				$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
				$db->setQuery($query);
				$lastcoupons = $db->loadAssocList();
			}
			
			// distrugge le vecchie chips
			if(count($lastcoupons)>0){
				// carica helper modulo reward points
				require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php');
				foreach($lastcoupons as $targetChip){
					modRewardPointsVmHelper::resetChip($targetChip['keyreference']);
				}
			}
		}
	 }
	 
	 
	 
	 function delete() {
	 	
	 	$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings();
		
		$referreid=JFactory::getApplication()->input->getString('referreid');
		$userid=JFactory::getApplication()->input->get('userid');
		$datareference = JFactory::getApplication()->input->getString('datareference');
		$rule = JFactory::getApplication()->input->getString('rule');
		$points = JFactory::getApplication()->input->get('points');
		
		// IMPORTANTE JOOMLA3 i valori data vengono passati senza formato
		$insert_date = JFactory::getApplication()->input->getString('insert_date');

		$db = JFactory::getDBO();
		
		// check if auto-chips all
		/*
		if($config['autochips_allchips'] == 1){
			rewardpointsvmModelUsers::reconvertChipBeforeModifying($referreid);
		}
		*/
		if($config['autochips_allchips'] != 1){			
			$query = "DELETE FROM #__virtuemart_rewardspoints_details ";
			$query .= "WHERE referreid='".$referreid."'  AND ";
			$query .= "datareference='".$datareference."' AND ";
			$query .= "rule='".$rule."' AND ";
			$query .= "insert_date='".$insert_date."' AND ";
			$query .= "points=".$points;
			$db->setQuery($query);
			$result = $db->execute();
			JFactory::getApplication()->enqueueMessage("Custom activity deleted", 'Message' );
		} else {
			
			// INSERIRE QUI un codice di miglioramento cancellazione attivita quando in autochip_all da amministratore
			$query = "DELETE FROM #__virtuemart_rewardspoints_details ";
			$query .= "WHERE referreid='".$referreid."'  AND ";
			$query .= "datareference='".$datareference."' AND ";
			$query .= "rule='".$rule."' AND ";
			$query .= "insert_date='".$insert_date."' AND ";
			$query .= "points=".$points;
			$db->setQuery($query);
			$result = $db->execute();
			//
			
			JFactory::getApplication()->enqueueMessage("Custom activity deleted", 'Message' );
			JFactory::getApplication()->enqueueMessage("Money Mode is on. Be sure to delete all other activities related to the one you just deleted.", 'Warning' );		
		}
	 }
	 
	 
	 
	 
	
	// registra i punti custom dal control panel user
	function store() {
		// mainframe alphauserpoints
		$referreid=JFactory::getApplication()->input->getString('referreid');
		$newPoints =  JFactory::getApplication()->input->get('newpoints');
		$userid=JFactory::getApplication()->input->get('userid');
		
		// codice qui
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings();
		
		if($referreid && $newPoints ) {
			$datareference = JFactory::getApplication()->input->getString('datareference');
			if(!$datareference) $datareference = "custom points";
			if(!$newPoints || !is_numeric($newPoints)) return;
			
			// mainframe VRP
			$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
			require_once ($api_VRP);
			
			if($newPoints<0 && $config['autochips']==1) { // esegue prima la riconversione punti
				// check if auto-chips all
				rewardpointsvmModelUsers::reconvertChipBeforeModifying($referreid);
			}
						
			RewardHelper::newPoints("plgaup_custom",$referreid, "custom points", $datareference, $newPoints);
			JFactory::getApplication()->enqueueMessage("Custom activity stored", 'Message' );
		}
		
		// esegue controllo punti e coupon se autochip_all eventualmente crea un unico grande coupon
		if($config['autochips_allchips'] == 1){
			
			JFactory::getApplication()->enqueueMessage("Money Mode is on. It will be created a single coupon with the user total points amount", 'Warning' );
			
		} else {
			// crea automaticamente una chip del valore dei punti appena assegnati se autochip
			if($config['autochips']==1){
				JLoader::import('joomla.application.component.model');
				JLoader::import( 'pointstocash', JPATH_ROOT .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_rewardpointsvm' .DIRECTORY_SEPARATOR. 'models' );
				$model = JModelLegacy::getInstance( 'pointstocash', 'rewardpointsvmModel' );
				
				$lang = JFactory::getLanguage();
				$lang->load('com_rewardpointsvm', JPATH_SITE, $lang->getTag(), true);		
				$currencysymbol = $config['coupon_currency_symbol'] ;
						
				// -------------------------------------------------------------------------
				$referreid = RewardHelper::getAnyUserReferreID( $userid ); // find user in AUP
				$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referreid );			
									
				if( $config['coupon_rounded'] == "rounded"){
					$newCouponValue =  floor($newPoints/$config['coupon_unit_points']);
				} else {
					$newCouponValue =  round($newPoints/$config['coupon_unit_points'],2);
				}
				// data di creazione coupon
				$_dtArray = getdate();
				$newCreationDate =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
				$newExpiryDate = $newCreationDate;
				if($config['awoexpiring'] >0)	{
					$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +".$config['awoexpiring']." days");
				} else {
					$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +365 days");
				}
				// formatta per mySql le date php
				$newCreationDate = date('Y-m-d G-i-s', $newCreationDate );
				$newExpiryDate = date('Y-m-d G-i-s', $newExpiryDate );
				// crea nuovo codice coupon
				
				$codecomplexity = 9;
				if($config['codecomplexity']) $codecomplexity = floor($config['codecomplexity']);
				$newCode = RewardHelper::generate_random_code($codecomplexity);	
						
				// -------------------------------------------------------------------------------
				// Crea coupon, paga con i punti e spedisce email
				// -------------------------------------------------------------------------------
				$newCoupon = $model->_createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate);
				$code_coupon = $model->_purchase_coupon($userid, $referreid, $newCoupon, $newPoints, $newCouponValue, $newExpiryDate );
				JFactory::getApplication()->enqueueMessage("New coupon created for user (option 'autochip' is ON in rewardpoints configuration)", 'Message' );
			}
		}
	}
	
	
	
}
?>