<?php
/*
 * @component RewardPointsVm
 * @copyright Copyright (C) 2102 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardspoints.com
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
jimport( 'joomla.mail.helper' );


class RewardpointsvmController extends JControllerLegacy {
	
 	function __construct()	{
		parent::__construct( );
	}
	
	function pointstocash($params=null) {
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		$app = JFactory::getApplication();
		$model  = $this->getModel ('pointstocash');
		$view  = $this->getView  ('pointstocash','html');
		$rmenuid	= $model->_getIdMenu();	
		if (!$params) $params = $model->_getParamsMenu();
		$user =  JFactory::getUser();
		$lang = JFactory::getLanguage();
		$language =  $lang->getTag();
		// -------------------------------------------------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		// controlla eventuali errori ---------------------------------------------------
		$error = "";
		if ( !$user->id ) $error = JText::_('VMAPTC_YOUMUSTBELOGGED' );	
		if (!$model->_checkVirtueMart()) $error = JText::_('VMAPTC_VIRTUEMART_NOT_INSTALLED' );
		if($config['couponmanager'] == "awo"){	
			if ( ! file_exists( JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php') ) $error = JText::_('VMAPTC_AWO_NOT_INSTALLED' );
		}
		if($user->id){
			$referrerid = RewardHelper::getAnyUserReferreID( $user->id );
			if($referrerid) $currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );
			if(! $referrerid) $error = JText::_('VMAPTC_ALERTNOTAUTH' );
		}
		// carica il contentId da mostrare, se esiste, e controlla guest eventuale
		if ($user->id ) {
			$article = $model->_getArticleDescription( $config['id_content_to_show_'.$language] );
		} else {
			$article = $model->_getArticleDescription( $config['id_content_to_guest_'.$language] );
		}
		if ($article) {
			$title = $article[0]->title;
			$description = $article[0]->introtext;
			$view->assign( 'title', $title );
			$view->assign( 'description', $description );
		}
		
		// prende i parametri del menu attivo
		$menus = JFactory::getApplication()->getMenu();
		$menu = $menus->getActive();
		if(isset($menu)){
 			$menuid = $menu->id;
 			$menuname = $menu->title;
		}else{
		// todo -> nel caso non esista cerca comunque tra i menu (risolve problema login con redirect a pagina cambio punti) 
		//$mainframe = JFactory::getApplication();
		//$mainframe->redirect(JRoute::_('index.php?option='.$mainframe->input->get('option').'&view='.$mainframe->input->get('view'),false));
			$menuid ="";
			$menuname ="";
		}
		// assegna parametri alla vista
		$view->assign( 'params', $params );
		if( isset($referrerid))	$view->assign( 'referreid', $referrerid );
		$view->assign( 'userid', $user->id );
		if( isset($currenttotalpoints))	$view->assign( 'currenttotalpoints', $currenttotalpoints );
		$view->assign( 'menuid', $rmenuid );
		$view->assign( 'menuname', $menuname );
		$view->assign( 'useremail', $user->email );
		if($error){
			$view->assign( 'status', 'error' );
		} else {
			$view->assign( 'status', 'show' );
		}
		$view->assign( 'error', $error );
		$view->assign('language', $language);
		$view->_display();
	}	
	
	
	
	
	
	function purchase($params=null) 	{
		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		$app = JFactory::getApplication();
		$model = $this->getModel ('pointstocash');
		$view = $this->getView  ('pointstocash','html');
		$lang = JFactory::getLanguage();
		$language =  $lang->getTag();
		$user =  JFactory::getUser();
		$useremail = $user->email;	
		$menus = JFactory::getApplication()->getMenu();
		$menu = $menus->getActive();
		$menuid = $menu->id;
		$menuname = $menu->title;	
		
		$params = $model->_getParamsMenu();
		$currencysymbol = $config['coupon_currency_symbol'] ;
		if( $config['coupon_rounded'] == "rounded"){
			$points = JFactory::getApplication()->input->get('points', 0, 'post', 'int');
			$newCouponValue =  floor($points/$config['coupon_unit_points']);
		} else {
			$points = JFactory::getApplication()->input->get('points', 0, 'post', '');
			$newCouponValue =  round($points/$config['coupon_unit_points'],2);
		}
		// -------------------------------------------------------------------------
		$referrerid = RewardHelper::getAnyUserReferreID( $user->id ); 
		$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );
		// abort in caso di errori - uguale a javascript ma non pu essere hackerata dal brower-editing
		$error = "";
		if($points < 0) $error =  JText::_('VMAPTC_NO_NEGATIVE_POINTS' );
		if(! $points || $points == 0 || ! is_numeric($points) ) $error =  JText::_('VMAPTC_NO_POINTS_TO_CHANGE_SET' );	
		if($points > $currenttotalpoints ) $error =  JText::_('VMAPTC_NOT_ENOUGH_POINTS' );		
		
		if(isset($multiplepoints)){
			if($multiplepoints && $points% $multiplepoints != 0 ) $error =  JText::_('VMAPTC_MULTIPLE_POINTS_REQUIRED' )." ".$multiplepoints;
		}
		if(isset($minpoints)){
			if($minpoints && $points < $minpoints ) $error =  JText::_('VMAPTC_MIN_POINTS_REQUIRED' )." ".$minpoints;	
		}
		if(isset($maxpoints)){
			if($maxpoints && $points > $maxpoints ) $error =  JText::_('VMAPTC_MAX_POINTS_REQUIRED' )." ".$maxpoints;	
		}
		if ( $error ) $app->redirect(JURI::current(), $error, 'error');
		// data di creazione coupon
		$_dtArray = getdate();
		$newCreationDate =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$newExpiryDate = $newCreationDate;
		if($config['awoexpiring'] >0)	{
			$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +".$config['awoexpiring']." days");
		} else {
			$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +365 days");
		}
		// formatta per mySql le date php
		$newCreationDate = date('Y-m-d G-i-s', $newCreationDate );
		$newExpiryDate = date('Y-m-d G-i-s', $newExpiryDate );
		// crea nuovo codice coupon
		function generate_random_code($length) {
			$string = "";
			for ($i = 0; $i <= ($length/32); $i++)
			$string .= md5(time()+rand(0,99));
			$max_start_index = (32*$i)-$length;
			$random_string = substr($string, rand(0, $max_start_index), $length);
			return $random_string;
		}
		$codecomplexity = 9;
		if($config['codecomplexity']) $codecomplexity = floor($config['codecomplexity']);
		$newCode = RewardHelper::generate_random_code($codecomplexity);	
		// -------------------------------------------------------------------------------
		// Crea coupon, paga con i punti e spedisce email
		// -------------------------------------------------------------------------------
		$newCoupon = $model->_createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate);
		$code_coupon = $model->_purchase_coupon($user->id, $referrerid, $newCoupon, $points, $newCouponValue, $newExpiryDate );
		// ritorna l'attuale punteggio
		$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );
		// inserisce l'articolo utilizzato come descrizione, se esiste
		$article = $model->_getArticleDescription( $config['id_content_to_show_'.$language] );
		if ( $article ) 	{
			$title = $article[0]->title;
			$description = $article[0]->introtext;
			$view->assign( 'title', $title );
			$view->assign( 'description', $description );
		}
	
		$view->assign( 'params', $params );
		$view->assign( 'menuname', $menuname );
		$view->assign( 'referreid', $referrerid );
		$view->assign( 'menuid', $menuid );
		$view->assign( 'menuname', $menuname );
		$view->assign( 'status', "success" );
		$view->assign( 'currenttotalpoints', $currenttotalpoints );
		$view->assign( 'codecoupon', $newCode );
		$view->assign( 'couponvalue', $newCouponValue );
		$view->assign( 'currencysymbol',  $currencysymbol );
		$view->assign( 'useremail', $useremail );
		$view->assign('language', $language);
		$view->assign('error', $error);
		
		// Display
		$view->_display();
	}
}
?>