<?php
/*
 * @component RewardPointsVm
 * @copyright Copyright (C) 2102 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardspoints.com
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class RewardHelper {
	
	
	
	
	public static function getSettings() {
		$db	= JFactory::getDBO(); 
		$q = "SELECT config FROM #__virtuemart_rewardspoints_config ";
		$db->setQuery($q);
		$result = $db->loadResult();
		$result = explode("(.)",$result);
		$config = array();
		// load earning configuration
		for($scan=0;$scan < count($result); $scan++){
			$string = explode("==",$result[$scan]);
			if(!isset($string[1])) $string[1] = "";
			$config[$string[0]] = $string[1];
		}
		return $config;
	}
		
		
		
	public static function checkRewardUserDb($user_id=false, $referreId=false){
	
		if(!$user_id && !$referreId) return false;
		
		$db	= JFactory::getDBO(); 
		// cerca nel db rewardpoints se trova il referrer.
		
		if(!$referreId){
			$q = "SELECT * FROM #__virtuemart_rewardspoints WHERE ";
			$q .= "virtuemart_user_id=".$user_id." AND referreid != 'pending_activation' ";
		} else {
			$q = "SELECT * FROM #__virtuemart_rewardspoints WHERE ";
			$q .= "referreid='".$referreId."' ";
		}
		$q .= "ORDER BY id ASC ";
		$db->setQuery($q);
		$vrpUser = $db->loadAssocList();
			
		// security check if there are two lines for the same user
		// stored in reward db by some payment method when registering user
		if(count($vrpUser)>1){
			$checkfirstline = false;
			// delete all line expect for the first on db
			$q = "DELETE FROM #__virtuemart_rewardspoints WHERE ";
			for($check=1; $check<count($vrpUser); $check++){
				if($checkfirstline) $q .="OR ";
				$q .= "id=".$vrpUser[$check]['id']." ";
				$checkfirstline = true;
			}
			$q .= ";";
			$db->setQuery($q);
			$result = $db->execute();
		}
		
		return $vrpUser[0];
	}
	
	
		
	public static function getAnyUserReferreID( $user_id ) {
		$db	= JFactory::getDBO(); 
		$vrpUser = RewardHelper::checkRewardUserDb($user_id);
		
		// se non lo trova, controlla che esiste l'utente in joomla (e sia attivato), se l'utente esiste, crea un utente nel vrp db
		if(! $vrpUser ) {
			$q = "SELECT * FROM #__users WHERE ";
			$q .= "id=".$user_id." AND ";
			$q .= "block=0 ";
			$db->setQuery($q);
			$jUser = $db->loadAssoc();
			if($jUser) {
				$q = "INSERT INTO #__virtuemart_rewardspoints (`virtuemart_user_id`, `referreid`, `points`) VALUES (".$user_id.", '".$jUser['username']."', 0.00); ";
				$db->setQuery( $q );
				$result = $db->execute();
			} else {
				return false;	
			}
			return $jUser['username'];
		}
		return $vrpUser['referreid'];		
	}
	
	
	
	public static function checkDuplicateActivities($referreId)	{
		// patch di correzione vecchie versioni - controlla se ci sono linee duplicate nel db
		// nel qual caso significa che l'errore si e' verificato almeno una volta.
		// si procede cancellando tutte le chip cambiate nel tempo dal database
		// poi si cancellano tutte le linee duplicate
		// infine si esegue il riconteggio
		// il test avviene tutto in ram, controlla solo la regola plgaup_vmalpharewardspoints
		// data oggi
		$_dtArray = getdate();
		$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$now = date('Y-m-d G-i-s', $now );		
		
		$db	= JFactory::getDBO(); 
		$q = "SELECT * FROM #__virtuemart_rewardspoints_details WHERE ";
		$q .= "referreid='".$referreId."' ";
		$q .= "AND rule='plgaup_vmalpharewardspoints' ";
		$q .= "AND (expire_date>='".$now."' OR expire_date='0000-00-00 00:00:00') ";
		$q .= "ORDER BY id DESC ;";
		$db->setQuery($q);
		$patchDuplicated = $db->loadAssocList();
		
		// controlla e costruisce eventuale lista id linee duplicate da cancellare
		$duplicatedListId = array();
		for($scan=0; $scan<count($patchDuplicated)-1; $scan++){ // non controlla l'ultima riga perche' all'ultima riga e' tutto gia' avvenuto
			for($scanDup=$scan+1; $scanDup<count($patchDuplicated); $scanDup++){
				$sourceCheck = $patchDuplicated[$scan];
				$comparingCheck = $patchDuplicated[$scanDup];
				if($comparingCheck["points"] == $sourceCheck["points"] && $comparingCheck["datareference"] == $sourceCheck["datareference"] && $comparingCheck["keyreference"] == $sourceCheck["keyreference"] && $comparingCheck["insert_date"] == $sourceCheck["insert_date"]){
					array_push($duplicatedListId, $comparingCheck['id']);
					break; // esce subito in modo che se le linee duplicate sono 3, la successiva sia trovata dopo e non raddoppiata in lista db
				}
			}
		}
		if(count($duplicatedListId)>0){
			// cancella tutte le linee duplicate
			$checkfirstline = false;
			$q = "DELETE FROM #__virtuemart_rewardspoints_details WHERE ";
			for($check=0; $check<count($duplicatedListId); $check++){
				if($checkfirstline) $q .="OR ";
				$q .= "id=".$duplicatedListId[$check]." ";
				$checkfirstline = true;
			}
			$q .= ";";
			$db->setQuery($q);
			$result = $db->execute();
			
			
			// trova le chips antecedenti la prima duplicazione, cancellale e cerca gli eventuali storni stesso codice e punti rovesciati)
			$q = "SELECT * FROM #__virtuemart_rewardspoints_details WHERE ";
			$q .= "referreid='".$referreId."' ";
			$q .= "AND id > ".$duplicatedListId[0]." ";
			$q .= "AND (expire_date>='".$now."' OR expire_date='0000-00-00 00:00:00') ";
			$q .= "ORDER BY id DESC ;";
			$db->setQuery($q);
			$patchDuplicatedChips = $db->loadAssocList();
			
			if(count($patchDuplicatedChips)>0){
				$duplicatedChipsId = array();
				for($scan=0; $scan<count($patchDuplicatedChips)-1; $scan++){
					if($patchDuplicatedChips[$scan]['rule'] == 'plgaup_vmalphapointstocash'){
						array_push($duplicatedChipsId, $patchDuplicatedChips[$scan]['id']);
						if($scan>0){
							$checkChipStorning = $patchDuplicatedChips[$scan-1];
							if($checkChipStorning['rule'] == 'plgaup_vmalpharewardspoints' && $checkChipStorning['points'] == -($patchDuplicatedChips[$scan]['points']) && $checkChipStorning['keyreference'] == $patchDuplicatedChips[$scan]['keyreference']) {
								array_push($duplicatedChipsId, $checkChipStorning['id']);
							}
						}
					}
				}
				
				$checkfirstline = false;
				$q = "DELETE FROM #__virtuemart_rewardspoints_details WHERE ";
				for($check=0; $check<count($duplicatedChipsId); $check++){
					if($checkfirstline) $q .="OR ";
					$q .= "id=".$duplicatedChipsId[$check]." ";
					$checkfirstline = true;
				}
				$q .= ";";
				$db->setQuery($q);
				$result = $db->execute();
			}
			return false;
		}
		return true;
	}
	
	
	public static function getCurrentTotalPoints($referreId) {
		$db	= JFactory::getDBO(); 
		$vrpUser = RewardHelper::checkRewardUserDb(false,$referreId);
		// data oggi
		$_dtArray = getdate();
		$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$now = date('Y-m-d G-i-s', $now );		
		
		$securityCheckDuplicateActivities = RewardHelper::checkDuplicateActivities($referreId);
				
		// get totale cliente
		$q = "SELECT points FROM #__virtuemart_rewardspoints_details WHERE ";
		$q .= "referreid='".$referreId."' ";
		$q .= "AND (expire_date>='".$now."' OR expire_date='0000-00-00 00:00:00') ;";
		$db->setQuery($q);
		$activitiesPoints = $db->loadColumn();
		
		if ($activitiesPoints){
			$result = round(array_sum($activitiesPoints),2);
		} else {
			$result = 0;
		}
		return $result;
	}
	
	
	public static function setPoints( $referreId , $points ) {
		$db = JFactory::getDBO(); 
		// set totale cliente
		$q = "UPDATE #__virtuemart_rewardspoints SET points=".$points." WHERE ";
		$q .= "referreid='".$referreId."';";
		$db->setQuery($q);
		$result = $db->execute();
		return $result;
	}
	
	
	public static function newPoints($plugin, $referreId, $activityKey="", $activityMessage="", $points, $validity="") {
		$db	= JFactory::getDBO(); 
		// data oggi
		$_dtArray = getdate();
		$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$now = date('Y-m-d G-i-s', $now );		
		if(!$validity) $validity = "0000-00-00 00:00:00";
		
		$q = "SELECT id FROM #__virtuemart_rewardspoints_details WHERE ";
		$q .= "referreid = '".$referreId."' AND rule ='".$plugin."' AND points = ".$points." AND keyreference = '".$activityKey."' AND ";
		$q .= "datareference = '".$activityMessage."' AND insert_date ='".$now."' ";
		$db->setQuery( $q );
		$checkIfDuplicated = $db->loadResult();
		
		$newPoints = RewardHelper::getCurrentTotalPoints($referreId);
		if(!$checkIfDuplicated) {
			// registra nuovo punteggio totale utente
			$newPoints += $points;
			$newTotalUserPoints = RewardHelper::setPoints($referreId, $newPoints);
			// registra transazione in db details QUESTO VIENE DOPO il precedente calcolo total points
			$q = "INSERT INTO #__virtuemart_rewardspoints_details (`referreid`, `rule`, `points`, `keyreference`, `datareference`, `insert_date`, `expire_date`) VALUES ('".$referreId."', '".$plugin."', ".$points.", '".$activityKey."', '".$activityMessage."', '".$now."', '".$validity."') ;";
			$db->setQuery( $q );
			$result = $db->execute();
			return $newTotalUserPoints;
		} else {
			return true;
		}
		
	}
	
	
	
	
	public static function getSetOrderPointsBackup($orderid, $referreId, $points=false, $ordernumber=false ) {
		if(!$points) $points = 0;
		$db	= JFactory::getDBO(); 
		// data oggi
		$_dtArray = getdate();
		$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$now = date('Y-m-d G-i-s', $now );		
		
		$q = "SELECT * FROM #__virtuemart_rewardspoints_refund WHERE ";
		$q .= "virtuemart_order_id = ".$orderid." AND referreid ='".$referreId."' ";
		$db->setQuery( $q );
		$line = $db->loadObject();
		
		if(!$line){
			if($points>0){ // set line solo nel caso in cui sia stata effettuata una richiesta con punti specifici, se no legge e basta
				$q = "INSERT INTO #__virtuemart_rewardspoints_refund (`virtuemart_order_id`, `order_number`, `referreid`, `points`,  `insert_date`) VALUES ('".$orderid."', '".$ordernumber."', '".$referreId."', ".$points.", '".$now."') ;";
				$db->setQuery( $q );
				$result = $db->execute();
			}
			return false;
		}
		
		return $line; // restituisce sempre la linea
	}
	
	
	
	
	
	public static function getListActivity($type='all', $userid='all', $numrows=0, $aup='') {
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		$nullDate	= $db->getNullDate();
		$date = JFactory::getDate();
		$now = $date->toSql();
		$typeActivity = "";
		$userID = "";
		switch ( $type )	{			
			case 'positive':
				$typeActivity = ">0";	
				break;	
			case 'negative':
				$typeActivity = "<0";
				break;
			case 'all':
			default:
				$typeActivity = "";
		}
		switch ( $userid ) {	
			case ( $userid>0 && $userid!='all' ):
				$userID = $userid;
				break;
			case ( $userid=0 ):
				return;
			case 'all':
			default:
				$userID = "";
		}
		
		if($aup==""){
			$referreId = RewardHelper::getAnyUserReferreID($userID);
			$securityCheckDuplicateActivities = RewardHelper::checkDuplicateActivities($referreId);
			$q = "SELECT * FROM #__virtuemart_rewardspoints_details WHERE referreid='".$referreId."' ";
			$q .= "AND (#__virtuemart_rewardspoints_details.expire_date >= '".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
			$q .= "AND #__virtuemart_rewardspoints_details.points".$typeActivity." ";
			$q .= "ORDER BY insert_date DESC ";
			$db->setQuery($q, 0, $numrows);
			$lastActivities = $db->loadAssocList();
		}
		return $lastActivities;
	}
	
	
	
	
	
	
	
	
	
	public static function rewardMail($email, $contentId, $contentParams="", $emailType="", $notifyAdmin="") {
			
		$config = RewardHelper::getSettings();
		
		jimport( 'joomla.mail.helper' );
		$application = JFactory::getApplication();
		$db	= JFactory::getDBO();
		
		// trova il content id
		$q = "SELECT * FROM #__content WHERE `id`=".$contentId;
		$db->setQuery($q);
		$content = $db->loadAssoc();
		
		$subject = $content['title'];
		$body = $content['introtext'];
		// esegue i replacement sia su titoli che su body
		foreach ($contentParams as $parameter) {
			$body = str_replace($parameter[0], $parameter[1],$body);
			$subject = str_replace($parameter[0], $parameter[1],$subject);
		}
		
		// email di notifica
		$mailer = JFactory::getMailer();
		
		// pulisce html se solo testo e setta tipologia email
		if($emailType == "plain") {
			$body = strip_tags($body);
		} else {
			$mailer->IsHTML(true);
			$mailer->Encoding = 'base64'; 
		}
		
		$jconfig = JFactory::getConfig();
		$SiteName 	= $jconfig->get( 'sitename' );
		$MailFrom 	= $jconfig->get( 'mailfrom' );
		$FromName 	= $jconfig->get( 'fromname' );
		
		$mailer->setSender(array($MailFrom, $FromName));
		
		// controlla se abilitata ricezione amministratore
		if(!$notifyAdmin) $notifyAdmin = 0;
		if($notifyAdmin!=0) $mailer->addBCC($MailFrom, $FromName);
		//
		$subject = JMailHelper::cleanSubject($subject);		
		$body    = JMailHelper::cleanBody($body);	
		$mailer->setSubject($subject);
		$mailer->setBody($body);
		
		$mailer->addRecipient($email);
		$send = $mailer->Send();
		if ( $send !== true ) {
		    $application->enqueueMessage('There was an error sending email: '.$send->message, 'error');
		    return false;
		} else {
			// invia una mail nel caso ci si trovi in frontend
			if ($application->isSite()) {
				// carica linguaggio virtuemart file orders
				$lang = JFactory::getLanguage();
				$extension = 'com_rewardpointsvm';
				$language_tag = $lang->getTag();
				$base_dir = JPATH_SITE;
				$reload = true;
				$lang->load($extension, $base_dir, $language_tag, $reload);
				$application->enqueueMessage(JText::sprintf('VMAPTC_MAIL_SENT',$email), 'message');
			}
		}	
		return true;
	}
		
	
	
	public static function generate_random_code($length) {
		$string = "";
		for ($i = 0; $i <= ($length/32); $i++)
		$string .= md5(time()+rand(0,99));
		$max_start_index = (32*$i)-$length;
		$random_string = substr($string, rand(0, $max_start_index), $length);
		return $random_string;
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	// funzione di sincronizzazione user e recover da vecchie tabelle aup se presenti 
	// FUNZIONA SOLO LA PRIMA VOLTA (config=initialize)
	public static function syncInternalUser() {
		
		// inizializza database internal
		$db	= JFactory::getDBO(); 
		$q = "TRUNCATE TABLE #__virtuemart_rewardspoints; ";
		$db->setQuery($q);
		$result = $db->execute();
		// inizializza dettagli attivit
		$q = "TRUNCATE TABLE #__virtuemart_rewardspoints_details; ";
		$db->setQuery($q);
		$result = $db->execute();
		
		
		
		// controlla se esiste AUP. Se esiste e esistono le sue tabelle db, check se details e' vuota se sì prendi gli utenti da li
		// nota: se details non e' vuota, sincronizza piu' tardi i punti usando i details.
		$AUP_copydb = false;
		$api_AUP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_alphauserpoints'.DIRECTORY_SEPARATOR.'helper.php';
		if (file_exists($api_AUP)) {
			//require_once ($api_AUP);
			$q = "SELECT * FROM #__alpha_userpoints_details ";
			$db->setQuery($q);
			$rows = $db->loadAssocList();	
			if(count($rows)==0) $AUP_copydb = true; 
		}
		
		if($AUP_copydb){ // solo nel caso non ci siano details, altrimenti vengono gestiti da funzione synch
			
			// copia tutti gli utenti AUP che esistano anche in joomla nel database interno
			$q = "SELECT #__users.id, #__users.username, #__alpha_userpoints.points FROM #__users, #__alpha_userpoints WHERE #__users.id = #__alpha_userpoints.userid AND #__alpha_userpoints.userid != 0";
			$db->setQuery($q);
			$rows = $db->loadAssocList();
						
			if(count($rows)>0){			
				
				$_dtArray = getdate();
				$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
				$now = date('Y-m-d G-i-s', $now );
					
				// inserisce su rewardpoints
				$safetyUsersBlockSynch = 50;
				$newQuery='INSERT INTO #__virtuemart_rewardspoints (`virtuemart_user_id`, `referreid`, `points`) VALUES ';
				
				for($scan=0; $scan < count($rows); $scan++){
					$newQuery .= "(".$rows[$scan]['id'].", '".$rows[$scan]['username']."', ".$rows[$scan]['points'].")";
					if($scan < count($rows)-1 || ($scan>0 && ($scan%$safetyUsersBlockSynch) == 0) ){
						$newQuery .= ", ";
					} else {
						// chiude la query totale o parte di essa (fino a numero specificato)
						$newQuery .= "; ";
						$db->setQuery($newQuery);
						$result = $db->execute();
						// resetta frase e riparte
						$newQuery='INSERT INTO #__virtuemart_rewardspoints (`virtuemart_user_id`, `referreid`, `points`) VALUES ';
					}
				}
				
				// ripete su rewardpoints details
				$newQuery='INSERT INTO #__virtuemart_rewardspoints_details (`referreid`, `rule`, `points`, `datareference`, `insert_date` ) VALUES ';
				$scanPointsExists = 0;
				for($scan=0; $scan < count($rows); $scan++){
					
					if($rows[$scan]['points'] >0) {// inserisce nei dettagli solo nel caso ci siano punti
						
						$newQuery .= "('".$rows[$scan]['username']."', 'plgaup_aupmigration', ".$rows[$scan]['points'].", 'Start points', '".$now."')";
						if($scan < count($rows)-1 || ($scan>0 && ($scanPointsExists%$safetyUsersBlockSynch) == 0) ){
							$newQuery .= ", ";
						} else {
							// chiude la query totale o parte di essa (fino a numero specificato)
							$newQuery .= "; ";
							$db->setQuery($newQuery);
							$result = $db->execute();
							// resetta frase e riparte
							$newQuery='INSERT INTO #__virtuemart_rewardspoints_details (`referreid`, `rule`, `points`, `datareference`, `insert_date` ) VALUES ';
						}
						$scanPointsExists ++;
					}
				}
								
			}
			
		} else {
			
			// copia tutti gli utenti JOOMLA nel database interno
			$q = "SELECT id, username FROM #__users ";
			$db->setQuery($q);
			$rows = $db->loadAssocList();
			
			if(count($rows)>0){				
				// inizializza
				$safetyUsersBlockSynch = 50;
				$newQuery='INSERT INTO #__virtuemart_rewardspoints (`virtuemart_user_id`, `referreid`, `points`) VALUES ';
				
				for($scan=0; $scan < count($rows); $scan++){
					$newQuery .= "(".$rows[$scan]['id'].", '".$rows[$scan]['username']."', 0.00)";
					if($scan < count($rows)-1 || ($scan>0 && ($scan%$safetyUsersBlockSynch) == 0) ){
						$newQuery .= ", ";
					} else {
						// chiude la query totale o parte di essa (fino a numero specificato)
						$newQuery .= "; ";
						$db->setQuery($newQuery);
						$result = $db->execute();
						// resetta frase e riparte
						$newQuery='INSERT INTO #__virtuemart_rewardspoints (`virtuemart_user_id`, `referreid`, `points`) VALUES ';
					}
				}
			}
			
		}		
		
		// inserisce cambio configurazione in config
		$q = "UPDATE  #__virtuemart_rewardspoints_config SET pointsmanager =  'internal' ; ";
		$db->setQuery($q);
		$result = $db->execute();			
	}
	
	
	
	
	
	
	
	
	
	public static function syncAupActivities() { // DA COMPLETARE
		
		// inizializza database internal
		$db	=& JFactory::getDBO(); 
		
		/*
		// carica righe dal database interno
		$q = "SELECT * FROM #__alpha_userpoints ";
		$db->setQuery($q);
		$rows = $db->loadAssocList();
		
		// date now
		$_dtArray = getdate();
		$now = mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$now = date('Y-m-d G-i-s', $now );	
			
		if(count($rows)>0){
			// trova l'utente nel db aup e utilizza regola migrazione per associare i punti
			foreach($rows as $row) {
				$q = "SELECT * FROM #__alpha_userpoints_details WHERE (`expire_date`>'".$now."' OR `expire_date`='0000-00-00 00:00:00') ";
				$q .="AND `referreid` = '".$row['referreid']."' ORDER BY `insert_date` ASC";
				$db->setQuery($q);
				$activities = $db->loadAssocList();
				$userid = $row['userid'];
				if(count($activities)>0){
					$vrpid = RewardHelper::getAnyUserReferreID($userid); // find user in VRP
					if ($vrpid) {
						foreach ($activities as $activity){
							//trova il nome della regola (se c'e') nel db rules aup
							$q = "SELECT `plugin_function` FROM #__alpha_userpoints_rules ";
							$q .="WHERE `id` = ".$activity['rule']." ";
							$db->setQuery($q);
							$rule = $db->loadResult();
							if (!$rule) $rule = "plgaup_auptorewardpoints";
							
							$q = "SELECT id FROM #__virtuemart_rewardspoints_details ";
							$q .="WHERE `referreid` = '".$vrpid."' AND `insert_date`='".$activity['insert_date']."' AND `points`=".$activity['points']." ";
							$db->setQuery($q);
							$checkActivity = $db->loadResult();
							if(!$checkActivity) {
								RewardHelper::newPoints( $rule,$vrpid,$activity['keyreference'], $activity['datareference'],$activity['points'],$activity['expire_date'] );
							}
						}
					}
				}
			}
		}
		// carica righe dal database VRP
		$q = "SELECT * FROM #__virtuemart_rewardspoints ";
		$db->setQuery($q);
		$rows = $db->loadAssocList();
		if(count($rows)>0){
			foreach($rows as $row) {
				$points = RewardHelper::getCurrentTotalPoints($row['referreid']);
				RewardHelper::setPoints($row['referreid'], $points );
			}
		}
			
		*/
	}
	
	
	
	
	
	
	
	
	
	
	// funzione di migrazione internal quando si utilizzava AUP ed era installato
	public static function migrateToInternal() {	
		// inizializza database internal
		$db	= JFactory::getDBO(); 
		// inserisce cambio configurazione in config
		$q = "UPDATE  #__virtuemart_rewardspoints_config SET pointsmanager =  'internal' ; ";
		$db->setQuery($q);
		$result = $db->execute();	
	}
	
	
	
	
	
	
	
	
	
	
		
		







	
	
	// funzione di check sistema AlphaUserPoints per migrazione punti e settaggio regole.
	public static function checkActivePointsManager() {
		$session = JFactory::getSession();
		if(!$session->get('rewardpoints_manager')){
			// controlla backup di configurazione
			$db	= JFactory::getDBO(); 
			$q = "SELECT pointsmanager FROM #__virtuemart_rewardspoints_config ";
			$db->setQuery($q);
			$checkConfig = $db->loadResult();
	
			if($checkConfig != "internal") {
				// attivata solo la prima volta che si installa l'estensione
				RewardHelper::syncInternalUser();
			}
			
			$session->set('rewardpoints_manager',true);
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	public static function checkCreditPointSystem() {
		
		$creditPlugin = JPATH_SITE.DIRECTORY_SEPARATOR.'plugins'.DIRECTORY_SEPARATOR.'vmpayment'.DIRECTORY_SEPARATOR.'creditpoints'.DIRECTORY_SEPARATOR.'creditpoints.php';
		if ( file_exists($creditPlugin)) {
			
			$session = JFactory::getSession();
			if(!$session->get('creditpoints_enabled')){	
				$session->set('creditpoints_enabled',true);
				
				$db	= JFactory::getDBO(); 
				
				// // installa payment credit points
				$q = "SELECT `virtuemart_custom_id` FROM #__virtuemart_customs WHERE ";
				$q .= "custom_element='vmcreditpoints' ";
				$db->setQuery($q);
				$checkRules = $db->loadResult();
				if( ! $checkRules) { 
					$q = "INSERT INTO #__virtuemart_customs (`custom_element`,`custom_title`,`field_type`, `is_cart_attribute` ) VALUES ('vmcreditpoints', 'Credit Points', 'S', 1 );";
					$db->setQuery( $q );
					$result = $db->execute();	
				}	
				
				// controlla che il plugin sia in ultima posizione
				$q = "UPDATE #__extensions SET ordering=100 WHERE ";
				$q .= "folder='vmpayment' AND type='plugin' AND element='creditpoints'";
				$db->setQuery($q);
				$result = $db->execute();
								
				// installa db savecarts 
				$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints_savecarts` (`rewardpoints_cart_id` INT AUTO_INCREMENT PRIMARY KEY, `virtuemart_user_id` INT, `virtuemart_vendor_id` INT, `cartData` VARBINARY(50000),  `created_on` DATETIME NOT NULL,  `created_by` INT NOT NULL,  `modified_on` DATETIME NOT NULL,  `modified_by` INT NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
				$db->setQuery($q);
				$result = $db->execute();
				
				// retrive virtuemart product credit points
				$q = "SELECT `virtuemart_paymentmethod_id` FROM #__virtuemart_paymentmethods WHERE ";
				$q .= "payment_element='creditpoints' AND published=1 ";
				$db->setQuery($q);
				$checkPaymenth = $db->loadResult();
				
				return $checkPaymenth;				
				
				
			}
			return false;
		}
		return false;
	}





	










	public static function autochip_all($userid){
		// ---------------------------------------------------------------------
		// AUTOCHIP
		// ---------------------------------------------------------------------
		// $this->autochip_all($user_id);
		// Autochip All Chips - destroy old chips if availables
		$chipCode = ""; // viene ritornato alla fine per essere utilizzato in auto-cart mode
		$config = RewardHelper::getSettings();
		if($config['autochips_allchips'] == 1){
			
			if($userid){ // solo se specificato da lancio funzione o utente loggato
				$db	= JFactory::getDBO();
				$date = JFactory::getDate();
				$now  = $date->toSql();
				
				$referrerid = RewardHelper::getAnyUserReferreID($userid); // find user in AUP
				$actualPoints = RewardHelper::getCurrentTotalPoints( $referrerid );
				// coupon virtuemart
				$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__virtuemart_coupons WHERE #__virtuemart_rewardspoints_details.referreid='".$referrerid."' ";
				$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
				$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
				$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
				$query .= "AND #__virtuemart_coupons.coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
				$query .= "AND #__virtuemart_coupons.published=1 ";
				$query .= "AND #__virtuemart_coupons.coupon_used='' ";
				$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
				$db->setQuery($query);
				$lastcoupons = $db->loadAssocList();
					
				// distrugge le vecchie chips nel caso ce ne siano piu' di una o una e ci sono punti
				if(count($lastcoupons)>1 || $actualPoints > 0){
					
					// carica helper modulo reward points
					require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php');
					foreach($lastcoupons as $targetChip){
						modRewardPointsVmHelper::resetChip($targetChip['keyreference']);
					}
					
					// ricostruisce unica chip con tutti i punti disponibili
					JLoader::import('joomla.application.component.model');
					JLoader::import( 'pointstocash', JPATH_ROOT .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_rewardpointsvm' .DIRECTORY_SEPARATOR. 'models' );
					$model = JModelLegacy::getInstance( 'pointstocash', 'RewardpointsvmModel' );
					
					$lang = JFactory::getLanguage();
					$lang->load('com_rewardpointsvm', JPATH_SITE, $lang->getTag(), true);		
					$currencysymbol = $config['coupon_currency_symbol'] ;
							
					// -------------------------------------------------------------------------
					$pointsChip = RewardHelper::getCurrentTotalPoints( $referrerid );
		
					if( $config['coupon_rounded'] == "rounded"){
						$newCouponValue =  floor($pointsChip/$config['coupon_unit_points']);
					} else {
						$newCouponValue =  round($pointsChip/$config['coupon_unit_points'],2);
					}
					
					// abort in caso di errori - uguale a javascript ma non pu essere hackerata dal brower-editing
					$error = false;
					if($pointsChip < 0) $error =  true;
					if(! $pointsChip || $pointsChip == 0 || ! is_numeric($pointsChip) ) $error =  true;	
					
					if (! $error ) {
						// data di creazione coupon
						$_dtArray = getdate();
						$newCreationDate =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
						$newExpiryDate = $newCreationDate;
						if($config['awoexpiring'] >0)	{
							$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +".$config['awoexpiring']." days");
						} else {
							$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +365 days");
						}
						// formatta per mySql le date php
						$newCreationDate = date('Y-m-d G-i-s', $newCreationDate );
						$newExpiryDate = date('Y-m-d G-i-s', $newExpiryDate );
						// crea nuovo codice coupon
						$codecomplexity = 9;
						if($config['codecomplexity']) $codecomplexity = floor($config['codecomplexity']);
						$newCode = RewardHelper::generate_random_code($codecomplexity);	
	
						// -------------------------------------------------------------------------------
						// Crea coupon, paga con i punti e spedisce email
						// -------------------------------------------------------------------------------
						$newCoupon = $model->_createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate);
						$code_coupon = $model->_purchase_coupon($userid, $referrerid, $newCoupon, $pointsChip, $newCouponValue, $newExpiryDate );
					}
				}

				
				
				// -------------------------------------------------------------------------------
				// modalità 'autocart' quando modo money mode attivato
				// -------------------------------------------------------------------------------
				if($config['allchips_autocart'] == 1){
					$mainframe = JFactory::getApplication();
					if ($mainframe->isSite()) {
						$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__virtuemart_coupons WHERE #__virtuemart_rewardspoints_details.referreid='".$referrerid."' ";
						$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
						$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
						$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
						$query .= "AND #__virtuemart_coupons.coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
						$query .= "AND #__virtuemart_coupons.published=1 ";
						$query .= "AND #__virtuemart_coupons.coupon_used='' ";
						$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
						$db->setQuery($query);
						$lastcoupons = $db->loadAssocList();
						if(count($lastcoupons)==1){
							$codecoupon = $lastcoupons[0]['coupon_code'];
							$valuecoupon = round($lastcoupons[0]['coupon_value'],2);
							// carica mainframe virtuemart
							if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'config.php');
		VmConfig::loadConfig();
							if(!class_exists('VirtueMartCart')) require(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'cart.php');
							$cart = VirtueMartCart::getCart(false);

							if($codecoupon != $cart->couponCode) {
								// togli il coupon dalla variable di sessione
								$cart->couponCode = "";
								$cart->_triesValidateCoupon = array();
								$cart->setCartIntoSession(true);
								// setta il coupon
								$msg = $cart->setCouponCode($codecoupon);
								$mainframe = JFactory::getApplication();
								$lang = JFactory::getLanguage();
								$lang->load('com_rewardpointsvm', JPATH_SITE, $lang->getTag(), true);		
								JFactory::getApplication()->enqueueMessage(JText::sprintf('VMAPTC_COUPON_CART_AUTOCART',$valuecoupon.$config['coupon_currency_symbol']), 'Warning' );
								$mainframe->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
							}
						}	
					}
				}
				
				
			}
		}
		
		return;
		
	}
	
	
	
	public static function restoreCart($userid=null) {
		
		$user = JFactory::getUser();
		$session = JFactory::getSession();
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		
		if($user->guest){			
			if($session->get('creditpoints_savecart') ){ // per utenti guest
				$savedCartDataDB = $session->get('creditpoints_savecart');
				if(!is_string($savedCartDataDB)) return;
				$savedCartDataDB = json_decode($savedCartDataDB);
			}
		} else {
			if(!$userid) {
				$userid = $user->id;
			}
			// carica mainframe virtuemart
			if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'config.php');
			VmConfig::loadConfig();
			VmConfig::loadJLang('com_virtuemart', true);
			if (!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'cart.php');
			// legge dal db rewardpoints savecarts
			$q = "SELECT * FROM #__virtuemart_rewardspoints_savecarts WHERE ";
			$q .= "virtuemart_user_id=".$userid;
			$db->setQuery($q);
			$savedCartDataDB = $db->loadObject();
		}	
				
		if($savedCartDataDB){
			
			$myCart = VirtueMartCart::getCart(false);
			
			// rimuove creditproduct eventualmente nel carrello attuale
			foreach($myCart->products as $product){
				// controlla se il prodotto e' un creditpoint
				$db = JFactory::getDBO();
				$q = "SELECT #__virtuemart_product_customfields.virtuemart_custom_id FROM #__virtuemart_customs, #__virtuemart_product_customfields WHERE ";
				$q .= "#__virtuemart_product_customfields.virtuemart_product_id = ".$product->virtuemart_product_id." AND ";
				$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id AND ";
				$q .= "#__virtuemart_customs.custom_element = 'vmcreditpoints'; ";
				$db->setQuery($q);
				$creditproduct = $db->loadResult();
				if($creditproduct) {
					//JError::raiseWarning(500, "trovato prodotto ".$product."con cart item ".$product->cart_item_id);
					$myCart->removeProductCart($product->cart_item_id);
				}
			}
			
			if($user->guest) {
				$productlist = $savedCartDataDB->cartProductsData;
			} else {
				$savedCartDataDB->cartData = json_decode($savedCartDataDB->cartData);
				$productlist = $savedCartDataDB->cartData->cartProductsData;
			}

			$myOldCart = VirtueMartCart::getCart(false);
			$myCart = VirtueMartCart::getCart(true);
			//$redirect = false;
			foreach($productlist as $product){
				
				// controlla se il prodotto e' un creditpoint
				$db = JFactory::getDBO();
				$q = "SELECT #__virtuemart_product_customfields.virtuemart_custom_id FROM #__virtuemart_customs, #__virtuemart_product_customfields WHERE ";
				$q .= "#__virtuemart_product_customfields.virtuemart_product_id = ".$product->virtuemart_product_id." AND ";
				$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id AND ";
				$q .= "#__virtuemart_customs.custom_element = 'vmcreditpoints'; ";
				$db->setQuery($q);
				$creditproduct = $db->loadResult();
				
				if(!$creditproduct){ // aggiunge solo se e' un prodotto regolare
					
					// controlla che non esista gia' in carrello altrimenti tiene la quantita' in carrello
					// (significa che l'utente aveva gia' ricaricato quel prodotto e settato la quantita)
					//JError::raiseWarning(500, print_r($myOldCart,true));
					vRequest::setVar('quantity',$product->quantity);
					foreach($myOldCart->products as $prodottocart){
						if($prodottocart->virtuemart_product_id == $product->virtuemart_product_id) {
							vRequest::setVar('quantity',$myOldCart->quantity);
							break;
						} 
					}
					vRequest::setVar('virtuemart_product_id',$product->virtuemart_product_id);
					vRequest::setVar('customProductData',$product->customProductData);
					$myCart->add((array)$product->virtuemart_product_id);
					$redirect = true;
				} 
			}
			
			
			$myCart->storeCart();
						
		
			
			$app->enqueueMessage(JText::_('VMPAYMENT_VCP_CART_RESTORED'), 'Message' );
			if($redirect) $app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',true));
			return true;			
		} else {
			return false;	
		}
	}





}