<?php
/*
 * @component RewardPointsVm
 * @copyright Copyright (C) 2102 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardspoints.com
 */
 
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class rewardpointsvmModelpointstocash extends JModelLegacy {

	function __construct(){		
		$lang = JFactory::getLanguage();
		$lang->load('com_rewardpointsvm', JPATH_SITE, $lang->getTag(), true);
		parent::__construct();		
	}
	
	function _getParamsMenu() {
		$menus = JFactory::getApplication()->getMenu();
		$menu = $menus->getActive();
		if(isset($menu)){
		$menuid = $menu->id;
		$params = $menus->getParams($menuid);
		} else {
			$params = null;
			}
		return $params;
	}
	
	function _getIdMenu() {
		$db	= JFactory::getDBO();
		$db->setQuery( "SELECT id FROM #__menu WHERE link='index.php?option=com_rewardpointsvm&view=pointstocash' AND published='1'" );		
		$realItemid = $db->loadResult();
		return $realItemid;		
	}
	
	function _getCodeCoupon( $id, $coupontype ) {
		if($coupontype == "virtuemart"){
			$vm_version = $this->_getVMVersion();
			$db	= JFactory::getDBO();
			$query = "SELECT `coupon_code` FROM #__virtuemart_coupons WHERE `virtuemart_coupon_id`='$id'";		
			$db->setQuery( $query );
			$result = $db->loadResult();
		}
		if($coupontype == "awo"){
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';
			if ( file_exists($awocoupon)) {
				require_once ($awocoupon);
			}
			$db	= JFactory::getDBO();
			$query = "SELECT `coupon_code` FROM #__".AWOCOUPON." WHERE `id`='".$id."'";	
			$db->setQuery( $query );
			$result = $db->loadResult();
		}
		return $result;
	}
	
	function _checkVirtueMart() {
		if ( file_exists( JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'virtuemart.php') ) {
			 return true;
		} else return false;
	}	
	
	
	
	function _createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate) {
		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		if ( file_exists($api_VRP)) require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		
		if($config['couponmanager'] == "virtuemart"){
			$couponType = "virtuemart";
			$db	= JFactory::getDBO();
			$query = "INSERT INTO `#__virtuemart_coupons` (`coupon_code`,`percent_or_total`,`coupon_type`,`coupon_value`,`coupon_start_date`,`coupon_expiry_date`,`created_on`,`modified_on`)
		  VALUES ('".$newCode."','total','gift','".$newCouponValue."','".$newCreationDate."','".$newExpiryDate."','".$newCreationDate."','".$newCreationDate."')";
			$db->setQuery($query);
			$db->execute();
			$creationId = $db->insertid();	
		}
		if($config['couponmanager'] == "awo"){
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';
			if ( file_exists($awocoupon)) {
				require_once ($awocoupon);
			} else {
				JFactory::getApplication()->enqueueMessage("Reward points is set to use Awo Coupon, but there is not Awo Coupon configuration file. Check Awo Coupon.", 'Warning' );
				return;
			}
			// differenze tra free da pro
			$coupon_value_type="total"; // awo free
			if($def_lists["coupon_value_type"]["amount"] || $AWOCOUPON_lang["coupon_value_type"]["amount"]) $coupon_value_type="amount"; // awo pro
			//
			$couponType = "awo";
			$db	= JFactory::getDBO();
			$query = "INSERT INTO `#__".AWOCOUPON."` (`coupon_code`,`num_of_uses`,`coupon_value_type`,`coupon_value`,`min_value`,`discount_type`,`function_type`,`startdate`,`expiration`,`published`)
		  VALUES ('".$newCode."',1,'".$coupon_value_type."','".$newCouponValue."','0.00','overall','giftcert','".$newCreationDate."','".$newExpiryDate."','1')";
			$db->setQuery($query);
			$db->execute();
			$creationId = $db->insertid();	
		}
		return ($creationId);
	}
	
	
	
	
	function _purchase_coupon( $user_id, $referrerid, $couponid, $points, $value_coupon, $validity ) {
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		if ( file_exists($api_VRP)) require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------

		$app = JFactory::getApplication();
		$db	= JFactory::getDBO();
		$code_coupon = $this->_getCodeCoupon( $couponid, $config['couponmanager']);
		$points = -$points;
		$datas = JText::_( 'VMAPTC_CODE' ) . " " . $code_coupon;
		
		// mainframe VRP
		require_once ($api_VRP);
		$currenttotalpoints = RewardHelper::newPoints( 'plgaup_vmalphapointstocash', $referrerid, $code_coupon, $datas, $points, $validity );	
				
		// ---------------------------------------------------------------------
		// INVIO EMAIL
		// ---------------------------------------------------------------------
		// controlla il linguaggio attivo dell'utente registrato all'acquisto
		$q = "SELECT `language` FROM #__virtuemart_rewardspoints_userlang WHERE `virtuemart_user_id` = ".$user_id;
		$db->setQuery($q);
		$language = $db->loadResult();
		if(! $language) {
			$lang = JFactory::getLanguage();
			$language = $lang->getTag();
		}
		// controlla se nel settaggio e' selezionato di inviare un email per questa lingua altrimenti NON invia
		if($config['coupon_email_message_'.$language]) {
			// trova l'utente registrato in joomla (in quanto deve essere registrato in joomla non in vm per funzionare)
			$q = "SELECT * FROM #__users WHERE `id` = ".$user_id;
			$db->setQuery($q);
			$userinfo = $db->loadAssoc();
			// trova il punteggio total
			$vrpid = RewardHelper::getAnyUserReferreID( $user_id ); 
			if ($vrpid) $newtotalpoints = RewardHelper::getCurrentTotalPoints($vrpid);
			
			/*
			content id = $config['coupon_email_message'.$language];
			content type = $config['coupon_email_type'];
			*/
			$contentParams = array(
				array( "{username}", $userinfo['username'] ),
				array( "{name}", $userinfo['name'] ),
				array( "{couponcode}", $code_coupon ),
				array( "{couponvalue}", $config['coupon_currency_symbol']."".$value_coupon ),
				array( "{newtotal}", $newtotalpoints )
			);
			//
			RewardHelper::rewardMail($userinfo['email'],$config['coupon_email_message_'.$language], $contentParams, $config['coupon_email_type'], $config['coupon_admin_notification']);
			//
		}

		return $code_coupon;
	}
	
	
	function _getArticleDescription ( $idArticle ){
		$db	= JFactory::getDBO();
		$query = "SELECT id, title, introtext FROM #__content WHERE id='$idArticle'";
		$db->setQuery( $query );
		$result = $db->loadObjectList();
		return $result;		
	}
	
	function _getVMVersion() {
		require_once (JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'version.php');
		return vmVersion::$RELEASE;
	}
	
}
?>