<?php
/*
 * @component rewardPointsVm
 * @copyright Copyright (C) 2104 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardspoints.com
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.installer.installer');

class com_RewardPointsVmInstallerScript {
	
 
	  function install($parent)  {
		
		$manifest = $parent->get("manifest");
		$parent = $parent->getParent();
		$source = $parent->getPath("source");
		//$source = JPATH_SITE;
		$installer = new JInstaller();
		$db = JFactory::getDBO();
		
		// Install plugins
		foreach($manifest->plugins->plugin as $plugin) {
			$attributes = $plugin->attributes();
			echo '<p>Installing Plugin '. $attributes->name .': ';
			$plg = $source . DIRECTORY_SEPARATOR . $attributes['folder'].DIRECTORY_SEPARATOR.$attributes['plugin'];
			if($installer->install($plg)){
				// publish plugin
				$query = "UPDATE #__extensions SET enabled='1' WHERE `element`='".$attributes['plugin']."' AND `type`='plugin' ";
				$db->setQuery( $query );
				$db->execute();
				echo '<strong>Success</strong>';
			} else {
				echo '<strong>Error</strong>';
			}
			echo "</p>";			
		}
	    
	    // Install modules
		foreach($manifest->modules->module as $module) {
			$attributes = $module->attributes();
			echo '<p>Installing Module '. $attributes->name .': ';
			$mod = $source . DIRECTORY_SEPARATOR . $attributes['folder'].DIRECTORY_SEPARATOR.$attributes['module'];
			if($installer->install($mod)){
				echo '<strong>Success</strong>';
			} else {
				echo '<strong>Error</strong>';
			}
			echo "</p>";
		}	
		
		
		
		
		
		$db	= JFactory::getDBO();
		$app = JFactory::getApplication();
		$error = 0;
		$cache = JFactory::getCache();
		$cache->clean( null, 'com_rewardpointsvm' );
		
		// ---------------------------------------------------------------
		// REWARD POINTS DATABASE
		// ---------------------------------------------------------------
		
		// settaggio configurazione interna iniziale 
		$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints_config` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `pointsmanager` TEXT NOT NULL, `config` TEXT NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		// virtuemart reward points 
		$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `virtuemart_user_id` INT NOT NULL, `referreid` TEXT NOT NULL, `points` DECIMAL( 10, 2 ) NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		// virtuemart reward points details 
		$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints_details` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `referreid` TEXT NOT NULL, `rule` TEXT NOT NULL, `points` DECIMAL( 10, 2 ) NOT NULL, `keyreference` TEXT NOT NULL, `datareference` TEXT NOT NULL, `insert_date` DATETIME NOT NULL, `expire_date` DATETIME NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		// virtuemart reward points refund 
		$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints_refund` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `referreid` TEXT NOT NULL, `virtuemart_order_id` INT NOT NULL, `order_number` TEXT NOT NULL, `points` DECIMAL( 10, 2 ) NOT NULL, `insert_date` DATETIME NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		// virtuemart reward points queued
		$q = "DROP TABLE IF EXISTS `#__virtuemart_rewardspoints_queue`; ";
		$db->setQuery($q);
		$result = $db->execute();
		$q = "CREATE TABLE `#__virtuemart_rewardspoints_queue` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `virtuemart_order_id` INT NOT NULL, `order_number` TEXT NOT NULL, `virtuemart_user_id` INT NOT NULL, `referreid` TEXT NOT NULL,`order_status` TEXT NOT NULL, `earned_points` DECIMAL( 10, 2 ) NOT NULL, `queue_date` DATETIME NOT NULL, `earn_date` DATETIME NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		// virtuemart reward points user languages
		$q = "CREATE TABLE IF NOT EXISTS `#__virtuemart_rewardspoints_userlang` (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY, `virtuemart_user_id` INT NOT NULL, `language` TEXT NOT NULL) CHARACTER SET `utf8` COLLATE `utf8_general_ci`;";
		$db->setQuery($q);
		$result = $db->execute();
		
		
		$q = "SELECT * FROM #__virtuemart_rewardspoints_config";
		$db->setQuery( $q );
		$result = $db->loadAssocList();	
		if(count($result)<1 ) {
			$q = "INSERT INTO #__virtuemart_rewardspoints_config (`pointsmanager`,`config`) VALUES ( 'initialize','status==C(.)restorestatus==R(.)rounded==rounded(.)orderpricesource==vat(.)excludediscountamount==include(.)excludediscountcustom==include(.)excludecustomwithcoupon==exclude(.)custompointstype==normal(.)pointsratio==1(.)pointsratio2threshold==(.)pointsratio2==(.)pointsratio3threshold==(.)pointsratio3==(.)pointsratio4threshold==(.)pointsratio4==(.)pointsratio5threshold==(.)pointsratio5==(.)min_order==(.)max_points==(.)validity==365(.)bannedpayment==(.)email_message_en-GB==(.)email_message_it-IT==(.)admin_notification==0(.)email_type==html(.)fixedpointbonus==(.)fixedpointbonusthreshold2==(.)fixedBonusPoints2==(.)fixedpointbonusthreshold3==(.)fixedBonusPoints3==(.)fixedpointbonusthreshold4==(.)fixedBonusPoints4==(.)fixedpointbonusthreshold5==(.)fixedBonusPoints5==(.)randompointbonusthreshold==(.)randompointbonus==(.)bonususernewregistration==(.)bonususerfirstorder==(.)bonususerfirstorder_rndmin==(.)bonususerfirstorder_rndmax==(.)bonususerordernumber==(.)bonususernumberpoints==(.)bonusordernumber==(.)bonusordernumberpoints==(.)bonusbirthdayfactor==(.)bonusbirthdaythreshold==(.)bonusbirthdayvalidity==(.)bonusperiodfactor1==(.)bonusperiodthreshold1==(.)bonusperioddatefrom1==(.)bonusperioddateto1==(.)bonusperiodfactor2==(.)bonusperiodthreshold2==(.)bonusperioddatefrom2==(.)bonusperioddateto2==(.)bonusperiodfactor3==(.)bonusperiodthreshold3==(.)bonusperioddatefrom3==(.)bonusperioddateto3==(.)bonusperiodfactor4==(.)bonusperiodthreshold4==(.)bonusperioddatefrom4==(.)bonusperioddateto4==(.)credit_system_hide_other==hide(.)credit_system_hide_credit==hide(.)credit_exclude_reward==exclude(.)credit_keep_bonus==keep(.)buy_credit_exclude_reward==exclude(.)buy_credit_keep_bonus==keep(.)credit_validity==(.)credit_email_type==html(.)coupon_unit_points==1(.)coupon_rounded==rounded(.)coupon_currency_symbol==€(.)codecomplexity==(.)awoexpiring==365(.)coupon_min_points==(.)coupon_max_points==(.)coupon_multiple_points==(.)couponmanager==virtuemart(.)autochips==0(.)autochips_allchips==0(.)allchips_autocart==0(.)id_content_to_show_en-GB==(.)id_content_to_show_it-IT==(.)id_content_to_guest_en-GB==(.)id_content_to_guest_it-IT==(.)hide_guest_toolbar==1(.)id_content_to_show_position==top(.)id_content_to_show_title==1(.)coupon_email_message_en-GB==(.)coupon_email_message_it-IT==(.)coupon_admin_notification==0(.)coupon_email_type==html' );";
			$db->setQuery( $q );
			$result = $db->execute();	
			
		}
		
		
				
		// ---------------------------------------------------------------
		// VIRTUEMART CUSTOM FIELDS
		// ---------------------------------------------------------------
		// virtuemart custom field per products custom points
		$q = "SELECT `virtuemart_custom_id` FROM #__virtuemart_customs WHERE ";
		$q .= "custom_element='rewardpointsvm' ";
		$db->setQuery($q);
		$checkRules = $db->loadResult();
		if( ! $checkRules) { 
			$q = "INSERT INTO #__virtuemart_customs (`custom_element`,`custom_title`,`field_type`, `is_cart_attribute` ) VALUES ('rewardpointsvm', 'Product Points', 'S', 0 );";
			$db->setQuery( $q );
			$result = $db->execute();	
		}
		
				
		
		
		
		
		// virtuemart birthday points
		// Sono installati dall'helper con la funzione checkCreditPointSystem();
		// virtuemart shopper field per birthday_date
		$q = "SELECT virtuemart_userfield_id FROM #__virtuemart_userfields WHERE ";
		$q .= "name='birthday_points' ";
		$db->setQuery($q);
		$checkRules = $db->loadResult();
		if( ! $checkRules) { 
			// inserisce il campo shopper nella lista campi
			$q = "INSERT INTO #__virtuemart_userfields (`name`, `title`, `type`, `maxlength`, `size`, `required`, `cols`, `rows`, `registration`, `shipment`, `account`, `readonly`, `calculated`, `sys`, `ordering`, `shared`, `published` ) VALUES ";
			$q .= "('birthday_points', 'Birthday', 'date', 25, 30, 0, 0, 0, 1, 0, 1, 0, 0, 0, 40, 0, 1); ";
			$db->setQuery($q);
			$result = $db->execute();	
			// aggiorna la tabella userinfo e inserisce la nuova colonna
			$q = "ALTER TABLE  #__virtuemart_userinfos ADD `birthday_points` DATE NULL ";
			$db->setQuery($q);
			$result = $db->execute();	
		}
		



		
		// pulisce variabile di sessione che controlla inizializzazione cosi' controlla il db se e' settato "internal" o puro, da nuova installazione
		$session = JFactory::getSession();
		if($session->get('rewardpoints_manager')) $session->clear('rewardpoints_manager');
				
		?>
		
		<table width="100%" border="0">
		<tr>
			<td>
			<h1>Reward Points for Virtuemart installed!</h1>
			<p>Official website: <a href="http://www.virtuemartrewardspoints.com" target="_blank">Follow us on http://www.virtuemartrewardspoints.com</a>	</p>
			</td>
		</tr>
		</table>
		
		
		
	<?php		
 	}
  
  
  
  
  
  

  	function update($parent)  {
    		$this->install($parent);		
   	 	echo '<p>Updating success</p>';
  	}






  	function uninstall($parent)  {
		
		// uninstall main plugin 
		$db = JFactory::getDBO();
		
		$plugin = '';
		$query = 'SELECT `extension_id`, `name` FROM #__extensions WHERE type = \'plugin\' AND element = \'rewardpointsvm\' AND folder = \'system\'';
		$db->setQuery($query);
		$plugin = $db->loadObject();
		
		if ($plugin->extension_id) {
			$installer = new JInstaller();
			if (!$installer->uninstall('plugin', $plugin->extension_id, 0)) {
					echo '<p>Plugin rewardpointsvm uninstall failed</p>';
					JError::raiseWarning(1, 'RewardPointsVmInstallerScript::uninstall(): plugin rewardpointsvm uninstall error');
			}
		}
		
		
		// uninstall new user plugin 
		$plugin = '';
		$query = 'SELECT `extension_id`, `name` FROM #__extensions WHERE type = \'plugin\' AND element = \'rewardpointsvm_newuser\' AND folder = \'user\'';
		$db->setQuery($query);
		$plugin = $db->loadObject();
		
		if ($plugin->extension_id) {
			$installer = new JInstaller();
			if (!$installer->uninstall('plugin', $plugin->extension_id, 0)) {
					echo '<p>Plugin rewardpointsvm_newuser uninstall failed</p>';
					JError::raiseWarning(1, 'RewardPointsVmInstallerScript::uninstall(): plugin rewardpointsvm_newuser uninstall error');
			}
		}
		
		// uninstall module 
		$module='';
		$query = 'SELECT `extension_id`, `name` FROM #__extensions WHERE type = \'module\' AND element = \'mod_rewardpointsvm\' ';
		$db->setQuery($query);
		$module = $db->loadObject();
		
		if ($module->extension_id) {
			$installer = new JInstaller();
			if (!$installer->uninstall('module', $module->extension_id, 0)) {
					echo '<p>Module mod_rewardpointsvm uninstall failed</p>';
					JError::raiseWarning(1, 'RewardPointsVmInstallerScript::uninstall(): module rewardpointsvm uninstall error');
			}
		}	
		
		
		// uninstall module prediction
		$module='';
		$query = 'SELECT `extension_id`, `name` FROM #__extensions WHERE type = \'module\' AND element = \'mod_rewardpointsvm_prediction\' ';
		$db->setQuery($query);
		$module = $db->loadObject();
		
		if ($module->extension_id) {
			$installer = new JInstaller();
			if (!$installer->uninstall('module', $module->extension_id, 0)) {
					echo '<p>Module mod_rewardpointsvm_prediction uninstall failed</p>';
					JError::raiseWarning(1, 'RewardPointsVmInstallerScript::uninstall(): module rewardpointsvm uninstall error');
			}
		}	
			
	}
	
	
	
}

?>
