<?php
/**
* @version		mod_rewardpointsvm.php 2012-20-05 v1.6.0
* @package		Virtuemart reward points extension 1.6.x and 1.7.x
* @copyright	Copyright (C) 2012. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modRewardPointsVmHelper {
	
	static function getPoints($params) 	{
		// carica foglio stile
		$points = 0;	
		$user = JFactory::getUser();  
		$userid = $user->id;  
		// mainframe alphauserpoints
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$vrpid = RewardHelper::getAnyUserReferreID( $userid ); 
		if ($vrpid) $points = RewardHelper::getCurrentTotalPoints($vrpid);
		return $points;
	}
	
	
	static function getListHistoryActivity($params) {
		$user = JFactory::getUser();  
		$userid = $user->id;
		$count = intval($params->get('lp_count', 5));	
		// mainframe VRP
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$lastpoints = RewardHelper::getListActivity("", $userid, $count);
		return $lastpoints;
	}
	
	
	static function getListEarnActivity($params) {
		$user = JFactory::getUser();  
		$userid = $user->id;
		$count = intval($params->get('lp_count', 5));	
		// mainframe VRP
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$lastpoints = RewardHelper::getListActivity("positive", $userid, $count);
		return $lastpoints;
	}
	
	
	static function getListChangedActivity($params) {
		$user = JFactory::getUser();  
		$userid = $user->id;
		$count = intval($params->get('lpn_count', 5));
		// mainframe VRP
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$lastpointsnegative = RewardHelper::getListActivity("negative", $userid, $count);
		return $lastpointsnegative;
	}
	
	
	
	static function getListCouponCodes($params) {
		$user = JFactory::getUser();  
		$userid = $user->id;
		$count = intval($params->get('cp_count', 5));
		$db = JFactory::getDBO();
		$nullDate	= $db->getNullDate();
		$date = JFactory::getDate();
		$now  = $date->toSql();
		// mainframe alphauserpoints
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		
		// controlla sistema cupon
		if($config['couponmanager']=="AWO") {
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';
			if ( file_exists($awocoupon)) {
				require_once ($awocoupon);
			} else {
				JFactory::getApplication()->enqueueMessage("Reward points is set to use Awo, but there is no Awo Coupon configuration file.", 'Warning' );
				return;
			}
		}
		$referreid = RewardHelper::getAnyUserReferreID( $userid ); 
		// coupon virtuemart
		if($config['couponmanager'] =="virtuemart") {
			$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__virtuemart_coupons WHERE #__virtuemart_rewardspoints_details.referreid='".$referreid."' ";
			$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
			$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
			$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
			$query .= "AND #__virtuemart_coupons.coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
			$query .= "AND #__virtuemart_coupons.published=1 ";
			$query .= "AND #__virtuemart_coupons.coupon_used='' ";
			$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
			$db->setQuery($query, 0, $count);
			$lastcoupons = $db->loadAssocList();
		}
		// coupon awo
		if($config['couponmanager'] =="awo") {
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';		
			require_once ($awocoupon);
			$query = "SELECT * FROM #__virtuemart_rewardspoints_details, #__".AWOCOUPON." WHERE #__virtuemart_rewardspoints_details.referreid='".$referreid."' ";
			$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
			$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
			$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
			$query .= "AND #__".AWOCOUPON.".coupon_code=#__virtuemart_rewardspoints_details.keyreference ";
			$query .= "AND #__".AWOCOUPON.".published=1 ";
			$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
			$db->setQuery($query, 0, $count);
			$lastcoupons = $db->loadAssocList();
		}
		//
		// aggiunge il settaggio dei colori chips
		/*
for ($scan=0; $scan<count($lastcoupons); $scan++){
			// table field: coupon_value
			$lastcoupons[$scan]['chips_color'] = $config['chips_color'];
			if($config['chips_color_threshold2'] && $lastcoupons[$scan]['coupon_value']>=$config['chips_color_threshold2']){
				$lastcoupons[$scan]['chips_color'] = $config['chips_color2'];
			} 
			if($config['chips_color_threshold3'] && $lastcoupons[$scan]['coupon_value']>=$config['chips_color_threshold3']){
				$lastcoupons[$scan]['chips_color'] = $config['chips_color3'];
			}
			if($config['chips_color_threshold4'] && $lastcoupons[$scan]['coupon_value']>=$config['chips_color_threshold4']){
				$lastcoupons[$scan]['chips_color'] = $config['chips_color4'];
			}
		}
*/
		return $lastcoupons;
	}
	
	
	
	
	
	static function resetChip($coupon_code) {
		
		//echo $coupon_code;
		
		$user = JFactory::getUser();  
		$userid = $user->id;
		$db = JFactory::getDBO();
		$nullDate	= $db->getNullDate();
		$date = JFactory::getDate();
		$now  = $date->toSql();
		// mainframe VRP
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		
		$language = JFactory::getLanguage();
		JFactory::getLanguage()->load('com_rewardpointsvm', JPATH_SITE, $language->getTag(), true);
		
		// $chipActivity
		// Array ( [0] => Array ( [id] => 858 [referreid] => 5094624DDFBA6 [points] => -2.00 [insert_date] => 2012-11-10 19:40:43 [expire_date] => 0000-00-00 00:00:00 [status] => 1 [rule] => 102 [approved] => 1 [keyreference] => f059fc610 [datareference] => Code f059fc610 ) )
		
		
		$referreid = RewardHelper::getAnyUserReferreID( $userid );
		// coupon virtuemart
		$query = "SELECT * FROM #__virtuemart_rewardspoints_details, ";
		if($config['couponmanager'] =="virtuemart") {
			$query .= "#__virtuemart_coupons ";
		}
		if($config['couponmanager'] =="awo") {
			$query .= "#__".AWOCOUPON." ";
		}
		$query .= "WHERE #__virtuemart_rewardspoints_details.referreid='".$referreid."' ";
		$query .= "AND #__virtuemart_rewardspoints_details.points<0 ";
		$query .= "AND #__virtuemart_rewardspoints_details.rule='plgaup_vmalphapointstocash' ";
		$query .= "AND (#__virtuemart_rewardspoints_details.expire_date>='".$now."' OR #__virtuemart_rewardspoints_details.expire_date='0000-00-00 00:00:00') ";
		$query .= "AND #__virtuemart_rewardspoints_details.keyreference = '".$coupon_code."' ";
		if($config['couponmanager'] =="virtuemart") {
			$query .= "AND #__virtuemart_coupons.coupon_code = '".$coupon_code."' ";
			$query .= "AND #__virtuemart_coupons.coupon_used='' ";
		}
		if($config['couponmanager'] =="awo") {
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';		
			require_once ($awocoupon);
			$query = "AND #__".AWOCOUPON.".coupon_code = '".$coupon_code."' ";
		}
		$query .= "ORDER BY #__virtuemart_rewardspoints_details.insert_date DESC ";
		$db->setQuery($query, 0);
		$chipActivity = $db->loadAssoc();
		// assegna in punti
		$aup_information =  JText::_('VMAPTC_COUPON_RESTORED_TO_CHIP' )." ".$coupon_code; // store info
		RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$referreid,$coupon_code,$aup_information,abs($chipActivity['points']),$chipActivity['expire_date'] );
		
		
		// cancella la chip
		if($config['couponmanager'] =="virtuemart") {
			$query = "DELETE FROM #__virtuemart_coupons WHERE ";	
		}
		// coupon awo
		if($config['couponmanager'] =="awo") {
			$awocoupon = JPATH_ADMINISTRATOR.'/components/com_awocoupon/awocoupon.config.php';		
			require_once ($awocoupon);
			$query = "DELETE FROM #__".AWOCOUPON." WHERE ";
		}
		$query .= "coupon_code = '".$coupon_code."' ";
		$db->setQuery($query);
		$result = $db->execute();		
		
		$mainframe = JFactory::getApplication();
		$mainframe->redirect(JRoute::_('index.php?option='.$mainframe->input->get('option').'&view='.$mainframe->input->get('view'),false));
		
		
		return;
	}
	
	
	
	static function useCoupon($coupon_code) {
				
		$mainframe = JFactory::getApplication();
				
		// carica mainframe virtuemart
		if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'config.php');
		VmConfig::loadConfig();
		VmConfig::loadJLang('com_virtuemart', true);
		if(!class_exists('VirtueMartCart')) require(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'cart.php');
		$cart = VirtueMartCart::getCart(false);
		
		
		if ($cart) {
			// togli il coupon dalla variable di sessione
			$cart->couponCode = "";
			$cart->_triesValidateCoupon = array();
			$cart->setCartIntoSession(true);
			// setta il coupon
			$msg = $cart->setCouponCode($coupon_code);
			$mainframe = JFactory::getApplication();			
			JFactory::getApplication()->enqueueMessage($msg, 'Warning' );
			$mainframe->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
		}
		
		
	}
	
	
	
	static function resetCoupon() {
		
		$mainframe = JFactory::getApplication();
		
		// carica mainframe virtuemart
		if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'config.php');
		VmConfig::loadConfig();
		VmConfig::loadJLang('com_virtuemart', true);
		if(!class_exists('VirtueMartCart')) require(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'cart.php');
		$cart = VirtueMartCart::getCart(false);
				
		if ($cart) {
			// togli il coupon dalla variable di sessione
			$cart->couponCode = "";
			$cart->_triesValidateCoupon = array();
			$cart->setCartIntoSession(true);
			JFactory::getApplication()->enqueueMessage(JText::_('VRP_CART_COUPON_CLEANED' ), 'Warning' );
			$mainframe->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
		}
	}
	
	
	
	// Questa funzione e' una duplicazione rivista del componente pointstocash
	// e deve essere disabilitata nel caso in cui ci si trovi nella pagina del componente
	// affinch la funzione non sia duplicata
	static function purchase() { 		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		$app = JFactory::getApplication();
		
		JLoader::import('joomla.application.component.model');
		JLoader::import( 'pointstocash', JPATH_ROOT .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_rewardpointsvm' .DIRECTORY_SEPARATOR. 'models' );
		$model = JModelLegacy::getInstance( 'pointstocash', 'RewardpointsvmModel' );
		$lang = JFactory::getLanguage();
		$language =  $lang->getTag();
		$user = JFactory::getUser();
		$useremail = $user->email;		
		
		$currencysymbol = $config['coupon_currency_symbol'] ;
		if( $config['coupon_rounded'] == "rounded"){
			$points = JFactory::getApplication()->input->get('points', 0, 'post', 'int');
			$newCouponValue =  floor($points/$config['coupon_unit_points']);
		} else {
			$points = JFactory::getApplication()->input->get('points', 0, 'post', '');
			$newCouponValue =  round($points/$config['coupon_unit_points'],2);
		}
		// -------------------------------------------------------------------------
		$referrerid = RewardHelper::getAnyUserReferreID( $user->id );
		$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );

		// abort in caso di errori - uguale a javascript ma non pu essere hackerata dal brower-editing
		$error = "";
		if($points < 0) $error =  JText::_('VMAPTC_NO_NEGATIVE_POINTS' );
		if(! $points || $points == 0 || ! is_numeric($points) ) $error =  JText::_('VMAPTC_NO_POINTS_TO_CHANGE_SET' );	
		if($points > $currenttotalpoints ) $error =  JText::_('VMAPTC_NOT_ENOUGH_POINTS' );		
		
		if(isset($multiplepoints)){
			if($multiplepoints && $points% $multiplepoints != 0 ) $error =  JText::_('VMAPTC_MULTIPLE_POINTS_REQUIRED' )." ".$multiplepoints;
		}
		if(isset($minpoints)){
			if($minpoints && $points < $minpoints ) $error =  JText::_('VMAPTC_MIN_POINTS_REQUIRED' )." ".$minpoints;	
		}
		if(isset($maxpoints)){
			if($maxpoints && $points > $maxpoints ) $error =  JText::_('VMAPTC_MAX_POINTS_REQUIRED' )." ".$maxpoints;	
		}
		
		if ( $error ) $app->redirect(JURI::current(), $error, 'error');
		// data di creazione coupon
		$_dtArray = getdate();
		$newCreationDate =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
		$newExpiryDate = $newCreationDate;
		if($config['awoexpiring'] >0)	{
			$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +".$config['awoexpiring']." days");
		} else {
			$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +365 days");
		}
		// formatta per mySql le date php
		$newCreationDate = date('Y-m-d G-i-s', $newCreationDate );
		$newExpiryDate = date('Y-m-d G-i-s', $newExpiryDate );
		// crea nuovo codice coupon
		$codecomplexity = 9;
		if($config['codecomplexity']) $codecomplexity = floor($config['codecomplexity']);
		$newCode = RewardHelper::generate_random_code($codecomplexity);	
		// -------------------------------------------------------------------------------
		// Crea coupon, paga con i punti e spedisce email
		// -------------------------------------------------------------------------------
		$newCoupon = $model->_createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate);
		$code_coupon = $model->_purchase_coupon($user->id, $referrerid, $newCoupon, $points, $newCouponValue, $newExpiryDate );
		// ritorna l'attuale punteggio
		$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );
		// parametri modulo
		$returnvalues = Array();
		$returnvalues['referreid']= $referrerid ;
		$returnvalues['status']="success";
		$returnvalues['currenttotalpoints'] = $currenttotalpoints;
		$returnvalues['newCode'] = $newCode;
		$returnvalues['newCouponValue'] = $newCouponValue;
		$returnvalues['currencysymbol'] = $currencysymbol;
		$returnvalues['useremail'] = $useremail;
		$returnvalues['language'] = $language;
		$returnvalues['error'] = $error;
		
		//$mainframe = JFactory::getApplication();
		//$mainframe->redirect(JRoute::_('index.php?option='.$mainframe->input->get('option').'&view='.$mainframe->input->get('view'),false));
		
		return $returnvalues;
	}
	
	static function checkSavedCartExists($userid){
		$db = JFactory::getDBO();
		$q = "SELECT virtuemart_cart_id FROM #__virtuemart_rewardspoints_savecarts WHERE ";
		$q .= "virtuemart_user_id=".$userid;
		$db->setQuery($q);
		$cartId = $db->loadResult();
		if($cartId){
			return true;
		} else {
			return false;
		}
	}
	
	
	
}
?>