<?php
/**
* @version		mod_rewardpointsvm_prediction.php 2012-27-11 v1.2.0
* @package		Virtuemart reward points extension 1.6.x and 1.7.x
* @copyright	Copyright (C) 2012. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modrewardpointsvm_predictionHelper {
	
	public static function pointsPrediction($cart,$order,$data){
				
		
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		$db = JFactory::getDBO();
		$pointsPrediction = array();
		$user = JFactory::getUser();
		if(! $user->guest) {
			$user_id = $user->get('id');
		} else {
			$user_id = false;
		}
		// carica impostazioni reward points
		$point_ratio =  $config['pointsratio'];
		$point_ratio2 =  $config['pointsratio2'];
		$point_ratio2threshold = '';
		if($point_ratio2) $point_ratio2threshold = $config['pointsratio2threshold'];
		$point_ratio3 =  $config['pointsratio3'];
		$point_ratio3threshold = '';
		if($point_ratio3) $point_ratio3threshold = $config['pointsratio3threshold'];
		$point_ratio4 =  $config['pointsratio4'];
		$point_ratio4threshold = '';
		if($point_ratio4) $point_ratio4threshold = $config['pointsratio4threshold'];
		$point_ratio5 =  $config['pointsratio5'];
		$point_ratio5threshold = '';
		if($point_ratio5) $point_ratio5threshold = $config['pointsratio5threshold'];
		
		// controllo bonus opzionali per fixed bonus
		$fixedBonusPoints = $config['fixedpointbonus'];
		$fixedpointbonusthreshold2 = $config['fixedpointbonusthreshold2'];
		$fixedBonusPoints2 = $config['fixedBonusPoints2'];
		$fixedpointbonusthreshold3 = $config['fixedpointbonusthreshold3'];
		$fixedBonusPoints3 = $config['fixedBonusPoints3'];
		$fixedpointbonusthreshold4 = $config['fixedpointbonusthreshold4'];
		$fixedBonusPoints4 = $config['fixedBonusPoints4'];
		$fixedpointbonusthreshold5 = $config['fixedpointbonusthreshold5'];
		$fixedBonusPoints5 = $config['fixedBonusPoints5'];
		
		$totalCreditPoints = 0;
		$totalEarnedPoints = 0;
		
		$totalEarnedPointsMax = 0;
		
		$totalEarnedReceipt = array();
		$targetOrdine = 0;
		$targetCustomPoints = 0;
	
	
		// ---------------------------------------------------------------------
		// MASTER ABORT in caso di errori dopo i credit prima dei rewards
		// ---------------------------------------------------------------------		
		$abort = false;	
				
		// abort in caso la tipologia di pagamento sia tra quelle bannate
		$bannedpayments = array();
		if($config['bannedpayment']){
			$bannedpayments = explode(",",$config['bannedpayment']);
			foreach($bannedpayments as $bannedpayment) {
				if($data->virtuemart_paymentmethod_id > 0 && $data->virtuemart_paymentmethod_id == $bannedpayment) {
					$abort = true;
					break;
				}
			}
		}	
		
		// abort in caso di minimo ordine
		if($config['min_order'] > 0 ) {
			if($config['orderpricesource'] == "base" ) {
				if($order['withTax'] - $order['taxAmount'] + $order['salesPriceCoupon'] < $config['min_order'] ) {
					$abort = true;
				}
			} else {
				if($order['withTax'] + $order['salesPriceCoupon'] < $config['min_order'] ) {
					$abort = true;
				}
			}
		}
		
		
		
		if(!$abort){
			
			// registra il totale dell'ordine per i treshold
			if($config['orderpricesource'] == "base" ) {
				$totaleCarrello = $order['withTax'] - $order['taxAmount'] + $order['salesPriceCoupon'];
			} else {
				$totaleCarrello = $order['withTax'] + $order['salesPriceCoupon'];
			}
		
			// trova il custom field rewardspoints ::VM2.x
			$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE ";
			$q .= "custom_element='rewardpointsvm' ";
			$db->setQuery($q);
			$customPointsFieldId = $db->loadResult();
					
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// CONTROLLO PUNTI DALL'ORDINE
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			
			// esegui il conteggio di tutti i punti dal carrello		
			foreach($cart->products as $product){
				// trova le linee dei prodotti
				$q = "SELECT * FROM #__virtuemart_products WHERE ";
				$q .= "product_sku='".$product['product_sku']."' ";
				$db->setQuery($q);
				$productDetails = $db->loadAssoc();
				// ----------------------------------------------------------------------
				// controlla se il prodotto ha dei custom points
				// ---------------------------------------------------------------------- 
				$customPoints = "";
				if($customPointsFieldId) {
					$q = "SELECT customfield_value FROM #__virtuemart_product_customfields WHERE ";
					$q .= "virtuemart_product_id='".$productDetails['virtuemart_product_id']."' AND ";
					$q .= "virtuemart_custom_id='".$customPointsFieldId."' ";
					$db->setQuery($q);
					$customPoints = $db->loadResult();
				}
												
				// calcolo dei punti con metono NORMALE
				if($config['custompointstype']=="normal" || $config['custompointstype']=="noratio") {
					if(isset($customPoints)) {
						if($product['subtotal_discount'] == 0 || $config['excludediscountcustom']=="include") {
							$targetCustomPoints += $customPoints*$product['quantity'];
						}
					} else {
						// converte stringa tipo '16,90 €' in '16.90 €' da cui estrae il numero giusto
						$product['subtotal_with_tax'] = str_replace(",", ".", $product['subtotal_with_tax']);
						$product['subtotal_tax_amount'] = str_replace(",", ".", $product['subtotal_tax_amount']);
						//
						if($product['subtotal_discount'] == 0 || $config['excludediscountamount']=="include") {
							if($config['orderpricesource'] == "base" ) {
								$targetOrdine += $product['subtotal_with_tax'] - $product['subtotal_tax_amount'] ; // iva esclusa
							} else {
								$targetOrdine += $product['subtotal_with_tax']; // iva inclusa
							}
						}
					}
				}
								
				// calcolo dei punti con metono BONUS
				if($config['custompointstype']=="bonus" || $config['custompointstype']=="nocustom") {
					if(isset($customPoints)) {
						if($product['subtotal_discount'] == 0 || $config['excludediscountcustom']=="include") {
							$targetCustomPoints += $customPoints*$product['quantity'];
						}
					}
					if($product['subtotal_discount'] == 0 || $config['excludediscountamount']=="include") {
						// converte stringa tipo '16,90 €' in '16.90 €' da cui estrae il numero giusto
						$product['subtotal_with_tax'] = str_replace(",", ".", $product['subtotal_with_tax']);
						$product['subtotal_tax_amount'] = str_replace(",", ".", $product['subtotal_tax_amount']);
						//
						if($config['orderpricesource'] == "base" ) {
							$targetOrdine += $product['subtotal_with_tax'] - $product['subtotal_tax_amount']; // iva esclusa
						} else {
							$targetOrdine += $product['subtotal_with_tax']; // iva inclusa
						}
					}
				}	
			}
			

			
			// togli dal conto totale dei punti guadagnati sul costo prodotto (non custom points) gli eventuali coupon
			if(!isset($config['excludecustomwithcoupon'])) $config['excludecustomwithcoupon'] = null;
			if($order['salesPriceCoupon']<0) {
				//excludecustomwithcoupon
				$targetOrdine += $order['salesPriceCoupon'];
				if($targetOrdine <0) $targetOrdine = 0;
				if($config['excludecustomwithcoupon'] == "exclude") $targetCustomPoints = 0;
			}	
			
			// controlla treshold opzionali
			if($point_ratio2threshold > 0 && $totaleCarrello >= $point_ratio2threshold) $point_ratio = $point_ratio2;
			if($point_ratio3threshold > 0 && $totaleCarrello >= $point_ratio3threshold) $point_ratio = $point_ratio3;
			if($point_ratio4threshold > 0 && $totaleCarrello >= $point_ratio4threshold) $point_ratio = $point_ratio4;
			if($point_ratio5threshold > 0 && $totaleCarrello >= $point_ratio5threshold) $point_ratio = $point_ratio5;
						
			// esegui calcolo point ratio e somma al totale custompoints
			if($config['custompointstype']=="noratio") {
				$targetPoints = $targetCustomPoints;	
			} else {
				if($config['custompointstype']=="nocustom") {
					$targetPoints = $targetOrdine*$point_ratio;	
				} else {
					$targetPoints = ($targetOrdine*$point_ratio) + $targetCustomPoints;	
				}
				$targetCustomOrder = $targetOrdine*$point_ratio; // backup per puro scopo dimostrativo non calcolo
			}					
			// ---------------------------------------------------------------------
			// CONTROLLA MASSIMO PUNTI
			// ---------------------------------------------------------------------
			if($config['max_points'] > 0 ) {
				if($targetPoints  > $config['max_points'] ) {
					$targetPoints = $config['max_points'];
				}
			}
			// ---------------------------------------------------------------------
			// CONTROLLA SE ARROTONDARE O MENO
			// ---------------------------------------------------------------------
			if($config['rounded'] == "rounded") {
				$targetPoints = floor($targetPoints);
				$targetCustomOrder = floor($targetCustomOrder);
			} else {
				$targetPoints = round($targetPoints,2);
				$targetCustomOrder = round($targetCustomOrder,2);
			}
			
			$totalEarnedPoints += $targetPoints;
			$totalEarnedPointsMax += $targetPoints;
			
			// ---------------------------------------------------------------------
			// OUTPUT PUNTI DALL'ORDINE
			// ---------------------------------------------------------------------
			$pointsPrediction['customPoints'] = $targetCustomPoints;
			$pointsPrediction['amountPoints'] = $targetCustomOrder;
		}
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		// CONTROLLO BONUS
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		
		// BONUS FIXED ORDINE
		// ---------------------------------------------------------------------
		if($config['fixedpointbonus'] > 0){
			
			// controlla treshold opzionali
			if($fixedpointbonusthreshold2 && $totaleCarrello >= $fixedpointbonusthreshold2) $fixedBonusPoints = $fixedBonusPoints2;
			if($fixedpointbonusthreshold3 && $totaleCarrello >= $fixedpointbonusthreshold3) $fixedBonusPoints = $fixedBonusPoints3;
			if($fixedpointbonusthreshold4 && $totaleCarrello >= $fixedpointbonusthreshold4) $fixedBonusPoints = $fixedBonusPoints4;
			if($fixedpointbonusthreshold5 && $totaleCarrello >= $fixedpointbonusthreshold5) $fixedBonusPoints = $fixedBonusPoints5;
			
		    $totalEarnedPoints += $fixedBonusPoints;
			$totalEarnedPointsMax += $fixedBonusPoints;
			$pointsPrediction['fixedPoints'] = $fixedBonusPoints;
		}
		
		
		
		
		
		
		
		
		// -------------------------------------------------------------------------
		// BIRTHDAY BONUS
		// -------------------------------------------------------------------------
		// preleva i dati del compleanno
		if($config['bonusbirthdayfactor'] >= 100 ) {
			if($user_id){
				// test minimo ordine
				$checkBirthdayThreshold	= false;
				if($config['bonusbirthdaythreshold'] > 0) {
					if($config['orderpricesource'] == "base") {
						if($totaleCarrello >= $config['bonusbirthdaythreshold']) {
							$checkBirthdayThreshold = true;
						}
					} else {
						if($totaleCarrello >= $config['bonusbirthdaythreshold']) {
							$checkBirthdayThreshold = true;
						}
					}
				} else {
					$checkBirthdayThreshold = true;
				}
				// se il test minimo e' superato, controlla se esistono dati compleanno, se si esegue la funzione
				if($checkBirthdayThreshold) {
					$db = JFactory::getDBO();
					$q = "SELECT `birthday_points` FROM #__virtuemart_userinfos WHERE virtuemart_user_id=".$user_id."; ";
					$db->setQuery($q);
					$birtday = $db->loadResult();	
										
					if($birtday){
						// data di confronto
						$dateNow = getdate();
						$dateNow =  mktime($dateNow['hours'], $dateNow['minutes'], $dateNow['seconds'], $dateNow['mon'], $dateNow['mday'], $dateNow['year']);
						//$dateNow = date('Y-m-d G-i-s', $dateNow );
						
						$birtdayDateNow = getdate();
						$birtday = explode("-",$birtday);
						$birtday[0] = $birtdayDateNow['year'];
						$birtday = implode("-",$birtday);					
						$birtday = strtotime(date("Y-m-d", strtotime($birtday)));
						
						if($config['bonusbirthdayvalidity']){
							$birtdayValidity = strtotime(date("Y-m-d", $birtday) . " +".$config['bonusbirthdayvalidity']." days");
						} else {
							$birtdayValidity = strtotime(date("Y-m-d", $birtday) . " +1 days");
						}
						if($dateNow >= $birtday && $dateNow < $birtdayValidity){
							// INSERIRE QUI LA FUNZIONE DI MODIFICA DEL VALORE
							$birthdayPoints = ($totalEarnedPoints*$config['bonusbirthdayfactor']/100)-$totalEarnedPoints;
							if($config['rounded'] == "rounded") {
								$birthdayPoints = floor($birthdayPoints);
							} else {
								$birthdayPoints = round($birthdayPoints,2);
							}
							if($birthdayPoints>0){
								$totalEarnedPoints += $birthdayPoints;
								$totalEarnedPointsMax += $birthdayPoints;	
								$pointsPrediction['birthdayPoints'] = $birthdayPoints;		
							}
						}
					}
				}
			} else {
				$pointsPrediction['loginAlert']="true";
			}			
		}

		
		
		
		
		// -------------------------------------------------------------------------
		// PROMOTIONAL PERIODS
		// -------------------------------------------------------------------------
		for($scan=1; $scan <=4; $scan++){
			// preleva i dati del compleanno
			if($config['bonusperiodfactor'.$scan] >100) {
				// test minimo ordine
				$checkPeriodThreshold = false;
				if($config['bonusperiodthreshold'.$scan] > 0) {
					
					if($config['orderpricesource'] == "base") {
						if($totaleCarrello >= $config['bonusperiodthreshold'.$scan]) {
							$checkPeriodThreshold = true;
						}
					} else {
						if($totaleCarrello >= $config['bonusperiodthreshold'.$scan]) {
							$checkPeriodThreshold = true;
						}
					}
				} else {
					$checkPeriodThreshold = true;
				}
				// se il test minimo e' superato, controlla se esistono dati compleanno, se si esegue la funzione
				if($checkPeriodThreshold) {	
					$periodStart = $config['bonusperioddatefrom'.$scan];	
					$periodEnd = $config['bonusperioddateto'.$scan];	
					if($periodStart && $periodEnd){
						// data di confronto
						$dateNow = getdate();
						$dateNow =  mktime($dateNow['hours'], $dateNow['minutes'], $dateNow['seconds'], $dateNow['mon'], $dateNow['mday'], $dateNow['year']);
						//$dateNow = date('Y-m-d G-i-s', $dateNow );
						$periodStart = strtotime(date("Y-m-d", strtotime($periodStart)));
						$periodEnd = strtotime(date("Y-m-d", strtotime($periodEnd)));
						// test excluding date
						$checkExcludingDays = true;
						$excludingDays = array("mon", "tue", "wed", "thu", "fri", "sat", "sun");
						foreach($excludingDays as $day){
							
							if(!isset($config['filterday_'.$day.$scan])) $config['filterday_'.$day.$scan] = null;
							
							if ( strtolower(date('D', $dateNow )) == strtolower($config['filterday_'.$day.$scan]) ){
								$checkExcludingDays=false;
							}
						}
						if($checkExcludingDays && $dateNow >= $periodStart && $dateNow < $periodEnd){
							// INSERIRE QUI LA FUNZIONE DI MODIFICA DEL VALORE
							$periodPoints = ($totalEarnedPoints*$config['bonusperiodfactor'.$scan]/100)-$totalEarnedPoints;
							if($config['rounded'] == "rounded") {
								$periodPoints = floor($periodPoints);
							} else {
								$periodPoints = round($periodPoints,2);
							}
							if($periodPoints>0){
								$totalEarnedPoints += $periodPoints;
								$totalEarnedPointsMax += $periodPoints;
								$pointsPrediction['periodPoints'] = $periodPoints;	
							}
						}
					}
				}			
			}
		}
		
		
		
		
		
		// -------------------------------------------------------------------------
		// RANDOM POINT RAFFLE BONUS
		// -------------------------------------------------------------------------
		if($config['randompointbonus'] > 0) {
			
			if(! $config['randompointbonusthreshold']) {
				$randomBonusThreshold = 0;
			 } else {
				 $randomBonusThreshold = $config['randompointbonusthreshold'];
			 }
			// echo $targetOrdine;
			 if($totaleCarrello >= $randomBonusThreshold){
				$totalEarnedPointsMax += $config['randompointbonus'];
				$pointsPrediction['randomPoints'] = $config['randompointbonus'];
			 }
		}
		
		
		
		
		
		
		// ---------------------------------------------------------------------------
		// BONUS PRIMO ORDINE USER e BONUS NUMERO ORDINI USER
		// ---------------------------------------------------------------------------
		if( ($config['bonususerfirstorder']>0 || $config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0) || ($config['bonususerordernumber'] > 0 && $config['bonususernumberpoints'] > 0) ) {
			if($user_id){
				// costruisce lista di metodi di pagamento da escludere nella ricerca del database
				$escludingPaymentQuery = '';
				if(count($bannedpayments)>0){
					foreach($bannedpayments as $bannedpayment) {
						$escludingPaymentQuery .= ' AND `virtuemart_paymentmethod_id`!='.$bannedpayment;
					}
				}					
				// cerca nel database gli ordini dell'utente
				$db = JFactory::getDBO();
				$q = 'SELECT COUNT(*) FROM `#__virtuemart_orders` WHERE `virtuemart_user_id`='.$user_id.' AND (`order_status`= "C" OR `order_status` = "S") '.$escludingPaymentQuery;
				$q.= ' ORDER BY `virtuemart_order_id` ' ;
				$db->setQuery($q);
				$userCountOrders = $db->loadResult();
				if(!$userCountOrders) $userCountOrders =0;
				// ----------------------------------------
				// PRIMO ORDINE USER
				if($config['bonususerfirstorder']>0 || $config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0){
					if( $userCountOrders == 0){
						
						$bonusFirstOrderPoints = $config['bonususerfirstorder'];
						$totalEarnedPoints += $bonusFirstOrderPoints;
						$totalEarnedPointsMax += $bonusFirstOrderPoints;
						$pointsPrediction['firstOrder'] = $bonusFirstOrderPoints;
						
						if($config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0){
							if(! $config['bonususerfirstorder_rndmin']) $config['bonususerfirstorder_rndmin'] = 0;
							// se non esiste rndmax o e' maggiore del rndmin lo setta a rndmin
							if(! $config['bonususerfirstorder_rndmax'] || $config['bonususerfirstorder_rndmax']<$config['bonususerfirstorder_rndmin']) { 
								$config['bonususerfirstorder_rndmax'] = $config['bonususerfirstorder_rndmin'] ;
							}
							
							$totalEarnedPointsMax += $config['bonususerfirstorder_rndmax'];
							$pointsPrediction['firstOrderRandom'] = $config['bonususerfirstorder_rndmax'];
							
							
						}
					}
				}
				// ----------------------------------------
				// NUMERO ORDINI USER
				if($config['bonususerordernumber'] > 0 && $config['bonususernumberpoints'] > 0){
					if( ($userCountOrders+1) % $config['bonususerordernumber'] == 0 ) {
						$totalEarnedPoints += $config['bonususernumberpoints'];
						$totalEarnedPointsMax += $config['bonususernumberpoints'];
						$pointsPrediction['userOrders'] = $config['bonususernumberpoints'];
					}
				}
			} else {
				if($config['bonususerfirstorder']>0 || $config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0){
					$pointsPrediction['loginAlert']="true";
				}
				if($config['bonususerordernumber'] > 0 && $config['bonususernumberpoints'] > 0){
					$pointsPrediction['loginAlert']="true";

				}
			}
		}
		
		
		
		
		
		
		
		
		// ---------------------------------------------------------------------
		// BONUS NUMERO ORDINI GLOBALE
		// ---------------------------------------------------------------------			
		if( $config['bonusordernumber'] > 0 && $config['bonusordernumberpoints'] > 0 ) {
		
			if($user_id){
				// costruisce lista di metodi di pagamento da escludere nella ricerca del database
				$escludingPaymentQuery = '';
				if(count($bannedpayments)>0){
					foreach($bannedpayments as $bannedpayment) {
						$escludingPaymentQuery .= ' AND `virtuemart_paymentmethod_id`!='.$bannedpayment;
					}
				}					
				// cerca nel database gli ordini dell'utente
				$db = JFactory::getDBO();
				$q = 'SELECT COUNT(*) FROM `#__virtuemart_orders` WHERE (`order_status`= "C" OR `order_status` = "S") '.$escludingPaymentQuery;
				$q.= ' ORDER BY `virtuemart_order_id` ' ;
				$db->setQuery($q);
				$countOrders = $db->loadResult();
				if( $countOrders+1 % $config['bonusordernumber'] == 0 ) {
					
					//$totalEarnedPoints += $config['bonusordernumberpoints'];
					$totalEarnedPointsMax += $config['bonusordernumberpoints'];
					$pointsPrediction['shopOrders'] = $config['bonusordernumberpoints'];
				}
			} else {
				
				$pointsPrediction['loginAlert']="true";
				
			}
		}
		
		$pointsPrediction['totalPoints'] = $totalEarnedPoints;		
		$pointsPrediction['totalPointsMax'] = $totalEarnedPointsMax;
		
		return $pointsPrediction;
	}
	
	
	
	
	
	
	
	
	public static function productPrediction($product_id,$order){
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		$db = JFactory::getDBO();
		$productPrediction = array();
		$user = JFactory::getUser();
		if(! $user->guest) $user_id = $user->get('id');

		// carica impostazioni reward points
		$point_ratio =  $config['pointsratio'];
		$point_ratio2 =  $config['pointsratio2'];
		$point_ratio2threshold = '';
		if($point_ratio2) $point_ratio2threshold = $config['pointsratio2threshold'];
		$point_ratio3 =  $config['pointsratio3'];
		$point_ratio3threshold = '';
		if($point_ratio3) $point_ratio3threshold = $config['pointsratio3threshold'];
		$point_ratio4 =  $config['pointsratio4'];
		$point_ratio4threshold = '';
		if($point_ratio4) $point_ratio4threshold = $config['pointsratio4threshold'];
		$point_ratio5 =  $config['pointsratio5'];
		$point_ratio5threshold = '';
		if($point_ratio5) $point_ratio5threshold = $config['pointsratio5threshold'];
		
		// controllo bonus opzionali per fixed bonus
		$fixedBonusPoints = $config['fixedpointbonus'];
		$fixedpointbonusthreshold2 = $config['fixedpointbonusthreshold2'];
		$fixedBonusPoints2 = $config['fixedBonusPoints2'];
		$fixedpointbonusthreshold3 = $config['fixedpointbonusthreshold3'];
		$fixedBonusPoints3 = $config['fixedBonusPoints3'];
		$fixedpointbonusthreshold4 = $config['fixedpointbonusthreshold4'];
		$fixedBonusPoints4 = $config['fixedBonusPoints4'];
		$fixedpointbonusthreshold5 = $config['fixedpointbonusthreshold5'];
		$fixedBonusPoints5 = $config['fixedBonusPoints5'];
		
		$totalEarnedPoints = 0;		
		$totalEarnedPointsMax = 0;
		
		$totalEarnedReceipt = array();
		$targetOrdine = 0;
		$targetCustomPoints = 0;
		
		// ---------------------------------------------------------------------
		// MASTER ABORT in caso di errori dopo i credit prima dei rewards
		// ---------------------------------------------------------------------		
						
		// trova il custom field rewardspoints ::VM2.x
		$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE ";
		$q .= "custom_element='rewardpointsvm' ";
		$db->setQuery($q);
		$customPointsFieldId = $db->loadResult();
		
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		// CONTROLLO PUNTI DALL'ORDINE
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		
		// trova le linee dei prodotti
		$q = "SELECT * FROM #__virtuemart_products WHERE ";
		$q .= "virtuemart_product_id=".$product_id." ";
		$db->setQuery($q);
		$productDetails = $db->loadAssoc();
		
		// trova le linee dei prodotti
		$q = "SELECT * FROM #__virtuemart_product_prices WHERE ";
		$q .= "virtuemart_product_id=".$product_id." ";
		$db->setQuery($q);
		$productPrices = $db->loadAssoc();
		
		// registra il totale dell'ordine per i treshold
		if($config['orderpricesource'] == "base" ) {
			$totaleCarrello = $order['withTax'] - $order['taxAmount'] + $order['salesPriceCoupon'];
		} else {
			$totaleCarrello = $order['withTax'] + $order['salesPriceCoupon'];
		}
		// trova i prezzi
		
		
		/*if (!class_exists ('calculationHelper')) {
			require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart' .DIRECTORY_SEPARATOR. 'helpers' .DIRECTORY_SEPARATOR. 'calculationh.php');
		}
		$product = (object)array_merge ((array)$productPrices, (array)$productDetails);
		$calculator = calculationHelper::getInstance();
		$productPrices = $calculator->getProductPrices($product);*/
		
		
		JLoader::import('joomla.application.component.model');
		JLoader::import( 'product', JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart' .DIRECTORY_SEPARATOR. 'models' );
		$model = JModelLegacy::getInstance( 'product', 'VirtueMartModel' );	
		$productPrices =  $model->getPrice($product_id,1);
			
		// ----------------------------------------------------------------------
		// controlla se il prodotto ha dei custom points
		// ---------------------------------------------------------------------- 
		$customPoints = "";
		if($customPointsFieldId) {
			$q = "SELECT customfield_value FROM #__virtuemart_product_customfields WHERE ";
			$q .= "virtuemart_product_id='".$productDetails['virtuemart_product_id']."' AND ";
			$q .= "virtuemart_custom_id='".$customPointsFieldId."' ";
			$db->setQuery($q);
			$customPoints = $db->loadResult();
		}
		// calcolo dei punti con metono NORMALE
		if($config['custompointstype']=="normal" || $config['custompointstype']=="noratio") {
			if(isset($customPoints)) {
				if($productPrices['discountAmount'] == 0 || $config['excludediscountcustom']=="include") {
					$targetCustomPoints += $customPoints;
				}
			} else {
				if($productPrices['discountAmount'] == 0 || $config['excludediscountamount']=="include") {
					if($config['orderpricesource'] == "base" ) {
						$targetOrdine += $productPrices['salesPrice'] - $productPrices['taxAmount']; // iva esclusa
					} else {
						$targetOrdine += $productPrices['salesPrice']; // iva inclusa
					}
				}
			}
		}
		// calcolo dei punti con metono BONUS
		if($config['custompointstype']=="bonus" || $config['custompointstype']=="nocustom") {
			if(isset($customPoints)) {
				if($productPrices['discountAmount'] == 0 || $config['excludediscountcustom']=="include") {
					$targetCustomPoints += $customPoints;
				}
			} 
			if($productPrices['discountAmount'] == 0 || $config['excludediscountamount']=="include") {
				if($config['orderpricesource'] == "base" ) {
					$targetOrdine += $productPrices['salesPrice'] - $productPrices['taxAmount']; // iva esclusa
				} else {
					$targetOrdine += $productPrices['salesPrice']; // iva inclusa
				}
			}
		}	

		// togli dal conto totale dei punti guadagnati sul costo prodotto (non custom points) gli eventuali coupon
		if($order['salesPriceCoupon']<0) {
			//excludecustomwithcoupon
			if($order['withTax']+$order['salesPriceCoupon'] <0) {
				$targetOrdine += $order['withTax']+$order['salesPriceCoupon']; // solo nel caso in cui ci sia del residuo negativo dal coupon in carrello
			}
			if(!isset($config['excludecustomwithcoupon'])) $config['excludecustomwithcoupon'] = null;
			if($targetOrdine <0) $targetOrdine = 0;
			if($config['excludecustomwithcoupon'] == "exclude") $targetCustomPoints = 0;
		}
		
		// controlla treshold opzionali
		if($point_ratio2threshold > 0 && $totaleCarrello >= $point_ratio2threshold) $point_ratio = $point_ratio2;
		if($point_ratio3threshold > 0 && $totaleCarrello >= $point_ratio3threshold) $point_ratio = $point_ratio3;
		if($point_ratio4threshold > 0 && $totaleCarrello >= $point_ratio4threshold) $point_ratio = $point_ratio4;
		if($point_ratio5threshold > 0 && $totaleCarrello >= $point_ratio5threshold) $point_ratio = $point_ratio5;
		
		// esegui calcolo point ratio e somma al totale custompoints
		if($config['custompointstype']=="noratio") {
			$targetPoints = $targetCustomPoints;	
		} else {
			if($config['custompointstype']=="nocustom") {
				$targetPoints = $targetOrdine*$point_ratio;	
			} else {
				$targetPoints = ($targetOrdine*$point_ratio) + $targetCustomPoints;	
			}
			$targetCustomOrder = $targetOrdine*$point_ratio; // backup per puro scopo dimostrativo non calcolo
		}					
		// ---------------------------------------------------------------------
		// CONTROLLA SE ARROTONDARE O MENO
		// ---------------------------------------------------------------------
		if($config['rounded'] == "rounded") {
			$targetPoints = floor($targetPoints);
			$targetCustomOrder = floor($targetCustomOrder);
		} else {
			$targetPoints = round($targetPoints,2);
			$targetCustomOrder = round($targetCustomOrder,2);
		}
		
		// ---------------------------------------------------------------------
		// OUTPUT PUNTI DALL'ORDINE
		// ---------------------------------------------------------------------
		$productPrediction = $targetCustomOrder+$targetCustomPoints;
		
		return $productPrediction;
	}	
	
	
	
}
?>