<?php
/**
* @version		mod_rewardpointsvm_prediction.php 2012-27-11 v1.2.0
* @package		Virtuemart reward points extension 1.6.x and 1.7.x
* @copyright	Copyright (C) 2012. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');
// carica foglio stile
$document = JFactory::getDocument();
$document->addStylesheet('modules/mod_rewardpointsvm_prediction/assets/css/style.css');
$user = JFactory::getUser();

/*
$points['customPoints']
$points['amountPoints']
$points['fixedPoints']
$points['birthdayPoints']
$points['periodPoints']
$points['randomPoints']
$points['firstOrder']
$points['firstOrderRandom']
$points['userOrders']
$points['shopOrders']
$points['totalPoints']		
$points['totalPointsMax']
$points['loginAlert']
*/

?>


<?php if($params->get('hide_category')){
	if (JFactory::getApplication()->input->get('view') == 'category' ){
		return;
		}
	}
?>
<?php if($params->get('hide_categories')){
	if (JFactory::getApplication()->input->get('view') == 'categories' ){
		return;
		}
	}
?>

<?php if($params->get('product_details')){
	if (JFactory::getApplication()->input->get('view') == 'productdetails' ){
		return;
		}
	}
?>
<?php if($params->get('cart')){
	if (JFactory::getApplication()->input->get('view') == 'cart' ){
		return;
		}
	}
?>

<?php
	if(!isset($productPoints)) $productPoints = null;
	if($params->get('product_prediction')) { 
		if($productPoints){ ?>
			<div class="productPrediction">
			<?php echo jText::sprintf(JText::_('VRPP_PRODUCT_AMOUNT_PREDICTION'), '<span>'.$productPoints.'</span>'); ?>
			</div>
		<?php }
	}
?>

<?php if($emptyCart){ ?>
	<?php if($params->get('empty_cart_show')) { ?>
		<div class="zeroPointsPrediction">
			<?php
				echo jText::_(JText::_('VRPP_POINTS_EMPTY_CART'));
			?>
			<div class="zeroPointsPredictionSubtitle">
				<?php echo jText::_(JText::_('VRPP_POINTS_ZERO_PREDICTION_SUBTITLE')) ?>
			</div>
		</div>
	<?php } ?>
<?php return;
	} ?>

<?php if($points['totalPoints'] > 0) { ?>
	<div class="totalPointsPrediction">
		<?php echo jText::sprintf(JText::_('VRPP_POINTS_PREDICTION'), '<span>'.$points['totalPoints'].'</span>') ?>
		
	</div>
	

	<?php 
	if($points['totalPoints'] < $points['totalPointsMax'] || $productPoints) {
		if($params->get('max_points_show')) {  
			$pointsDiff = $points['totalPointsMax']-$points['totalPoints'];
			?>
			<div class="totalPointsMaxPrediction">
				<?php if($productPoints) { ?>
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_MAX_PREDICTION'), '<span>'.($points['totalPointsMax']+$productPoints).'</span>') ?>
					<div class="totalPointsProductPrediction">
						<?php echo jText::sprintf(JText::_('VRPP_POINTS_MAX_PREDICTION_WITH_PRODUCT'), '<span>'.($productPoints).'</span>') ?>
					</div>
				<?php } else { ?>
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_MAX_PREDICTION'), '<span>'.$points['totalPointsMax'].'</span>') ?>
				<?php } ?>
				<?php if($pointsDiff>0) { ?>
					<div class="totalPointsRandomPrediction">
						<?php echo jText::sprintf(JText::_('VRPP_POINTS_MAX_PREDICTION_DIFF'), '<span>'.$pointsDiff.'</span>') ?>
						</div>
				<?php } ?>
			</div>
		<?php } 
		} 
	} else { ?>
		<div class="zeroPointsPrediction">
		<?php echo jText::_(JText::_('VRPP_POINTS_ZERO_POINTS_PREDICTION')); ?>
		</div>
<?php } ?>




<?php if($params->get('receips_show')) { ?>
	<div class="receips">
			
		<?php if($productPoints) { ?>
			<div class="receipsDetail product">
				<?php echo jText::sprintf(JText::_('VRPP_PRODUCT_POINTS_RECEIPS'), '<span>'.$productPoints.'</span>' ) ?>
			</div>
		<?php } ?>	

		
		<?php if (isset($points['amountPoints'])) { ?>
			<?php if($points['amountPoints']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_AMOUNT'), '<span>'.$points['amountPoints'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['customPoints'])) { ?>
			<?php if($points['customPoints']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_CUSTOM'), '<span>'.$points['customPoints'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['fixedPoints'])) { ?>
			<?php if($points['fixedPoints']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_FIXED'), '<span>'.$points['fixedPoints'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['birthdayPoints'])) { ?>
			<?php if($points['birthdayPoints']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_BIRTHDAY'), '<span>'.$points['birthdayPoints'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['periodPoints'])) { ?>
			<?php if($points['periodPoints']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_PROMOTIONAL'), '<span>'.$points['periodPoints'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['firstOrder'])) { ?>
			<?php if($points['firstOrder']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_FIRST_ORDER'), '<span>'.$points['firstOrder'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
		
		<?php if (isset($points['userOrders'])) { ?>
			<?php if($points['userOrders']>0) { ?>
				<div class="receipsDetail">
					<?php echo jText::sprintf(JText::_('VRPP_POINTS_USER_ORDER'), '<span>'.$points['userOrders'].'</span>' ) ?>
				</div>
			<?php } ?>
		<?php } ?>
	
	
		<?php if($params->get('receips_raffle_show')) { ?>
			
			<?php if (isset($points['randomPoints'])) { ?>
				<?php if($points['randomPoints']>0) { ?>
					<div class="receipsDetail">
						<?php echo jText::sprintf(JText::_('VRPP_POINTS_RANDOM'), '<span class="raffle">'.$points['randomPoints'].'</span>' ) ?>
					</div>
				<?php } ?>
			<?php } ?>
			
			<?php if (isset($points['firstOrderRandom'])) { ?>
				<?php if($points['firstOrderRandom']>0) { ?>
					<div class="receipsDetail">
						<?php echo jText::sprintf(JText::_('VRPP_POINTS_FIRST_ORDER_RANDOM'), '<span class="raffle">'.$points['firstOrderRandom'].'</span>' ) ?>
					</div>
				<?php } ?>
			<?php } ?>
			
			<?php if (isset($points['shopOrders'])) { ?>	
				<?php if($points['shopOrders']>0) { ?>
					<div class="receipsDetail">
						<?php echo jText::sprintf(JText::_('VRPP_POINTS_SHOP_ORDER'), '<span class="raffle">'.$points['shopOrders'].'</span>' ) ?>
					</div>
				<?php } ?>
			<?php } ?>
			
		<?php } ?>
					
	</div>
<?php } ?>

<?php if (!isset($points['loginAlert'])) $points['loginAlert']=""; ?>
<?php if($user->guest && $points['loginAlert']) { ?>
	<div class="receipsEnd">
		<?php echo jText::_(JText::_('VRPP_POINTS_BONUS_LOGIN_REQUEST')) ?>
	</div>
<?php } ?>






