<?php

/**
 * @version $Id: vmalpharewardspoints.php, v 2.0
 * @author Marco Coan
 * @package System
 * @copyright Copyright (C) 2012 Marco Coan - All rights reserved.
 * @coding developed in www.virtuemartrewardspoints.com on feb.2012
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 * http://virtuemart.org
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );


class plgSystemRewardpointsvm extends JPlugin {
	
	
	
	function onAfterDispatch(){
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		if ( file_exists($api_VRP)) require_once ($api_VRP);
		$creditPointsPaymentId = RewardHelper::checkCreditPointSystem(); // cerca solo se non esiste variabile sessione (from v.3)
		RewardHelper::checkActivePointsManager(); // cerca solo se non esiste variabile sessione (from v.3)
		
		// moneymode for logged user
		// ---------------------------------------------------------------------
		$user = JFactory::getUser();
		if(!$user->guest){
			$config = RewardHelper::getSettings();
			if($config['autochips_allchips'] == 1){
				if($user->id) RewardHelper::autochip_all($user->id);
			}
		}
	}
	
	
	

	function onAfterRoute(){
		
		$app = JFactory::getApplication();
		if(!$app->isAdmin()){
		
			// for creditpoints - switch the vendor currency from credit to master
			// ---------------------------------------------------------------------
			$session = JFactory::getSession();
			if($session->get('creditpoints_enabled')) {
			
				// carica configurazione virtuemart reward points --------------------------------
				$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
				if ( file_exists($api_VRP)) require_once ($api_VRP);
				$config = RewardHelper::getSettings();
				
				// va settata la regular_payment SOLO nel caso in cui si tratta di creditproduct browsepage, detail e cart.
				// in tutti gli altri casi va mantenuto il credit
				
				if(!isset($config['credit_switch_currency'])) $config['credit_switch_currency'] = null;
				if(!isset($config['credit_currency'])) $config['credit_currency'] = null;
				if(!isset($config['master_currency'])) $config['master_currency'] = null;
								
				$db = JFactory::getDBO();
				
				if($config['credit_switch_currency']==1 && $config['credit_currency'] && $config['master_currency'] ){	
					$creditCurrencyId = $config['credit_currency'];
					$regularCurrencyId = $config['master_currency'];
					$sessionCurrency = null;				
					$creditproduct = null;
					// ---------------------------------------------------------------------
					// product details
					// ---------------------------------------------------------------------
					if($app->input->get('option')=="com_virtuemart" && $app->input->get('view')=="productdetails") {
						$productId = $app->input->get('virtuemart_product_id');					
						// controlla se il prodotto e' un creditproduct
						$q = "SELECT * FROM #__virtuemart_product_customfields, #__virtuemart_customs WHERE ";
						$q .= "#__virtuemart_product_customfields.virtuemart_product_id = ".$productId." AND ";
						$q .= "#__virtuemart_customs.custom_element='vmcreditpoints' AND ";
						$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id ;";
						$db->setQuery($q);
						$creditproduct = $db->loadAssocList();
					}
					// ---------------------------------------------------------------------
					// cart
					// ---------------------------------------------------------------------
					if($app->input->get('option')=="com_virtuemart" && $app->input->get('view')=="cart") {
						// carica mainframe virtuemart
						if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'config.php');
						VmConfig::loadConfig();
						if(!class_exists('VirtueMartCart')) require(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_virtuemart'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'cart.php');
						$cart = VirtueMartCart::getCart(false);
						$creditproduct = false;
						//JError::raiseWarning(500, print_r($cart->cartProductsData,true));
						foreach ($cart->cartProductsData as $item){
							// controlla se il prodotto e' un creditproduct
							$q = "SELECT * FROM #__virtuemart_product_customfields, #__virtuemart_customs WHERE ";
							$q .= "#__virtuemart_product_customfields.virtuemart_product_id = ".$item['virtuemart_product_id']." AND ";
							$q .= "#__virtuemart_customs.custom_element='vmcreditpoints' AND ";
							$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id ;";
							$db->setQuery($q);
							$creditproduct = $db->loadAssocList();
							if($creditproduct) break;
						}
					}
					// ---------------------------------------------------------------------
					// category
					// ---------------------------------------------------------------------
					if($app->input->get('option')=="com_virtuemart" && $app->input->get('view')=="category") {
						//JError::raiseWarning(500, $app->input->get('virtuemart_category_id'));
						$categoryId = $app->input->get('virtuemart_category_id');
						// controlla uno qualsiasi dei prodotti in categoria	
						$q = "SELECT * FROM #__virtuemart_product_customfields, #__virtuemart_customs, #__virtuemart_product_categories WHERE ";
						$q .= "#__virtuemart_product_categories.virtuemart_category_id = ".$categoryId." AND ";
						$q .= "#__virtuemart_product_customfields.virtuemart_product_id = #__virtuemart_product_categories.virtuemart_product_id AND ";
						$q .= "#__virtuemart_customs.custom_element='vmcreditpoints' AND ";
						$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id ;";
						$db->setQuery($q);
						$creditproduct = $db->loadAssocList();
					}
					// ---------------------------------------------------------------------
					// sezione comune
					// ---------------------------------------------------------------------
					if($creditproduct){
						// se e' un creditproduct, cambia la currency in moneta (query SOLO NEL CASO non lo sia)
						$q = "UPDATE #__virtuemart_vendors SET vendor_currency=".$regularCurrencyId." WHERE virtuemart_vendor_id=1 AND vendor_currency!=".$regularCurrencyId." ";
						$sessionCurrency = $regularCurrencyId;
					} else {
						// in TUTTE le altre pagine in cui non e' un credit, cambia la currency in credit (query SOLO NEL CASO non lo sia)
						$q = "UPDATE #__virtuemart_vendors SET vendor_currency=".$creditCurrencyId." WHERE virtuemart_vendor_id=1 AND vendor_currency!=".$creditCurrencyId." ";
						$sessionCurrency = $creditCurrencyId;
					}
					$db->setQuery($q);
					$result = $db->execute();
					if($session->get('vmcart', 0, 'vm') && $sessionCurrency){ // la sessione va cambiata solo se esiste o genera errore
						$vmcart = ($session->get('vmcart', 0, 'vm') );
						$vmcart = json_decode($vmcart);
						$vmcart->paymentCurrency = (integer)$sessionCurrency;
						$vmcart->pricesCurrency = (integer)$sessionCurrency;
						$vmcart = json_encode($vmcart);
						$session->set('vmcart', $vmcart, 'vm');
					}
				}	
			}
		}
	}


		
	
	 
	function plgVmOnUserOrder($_orderData) { // fired quando viene creato l'ordine con confirmed order
		// ----------------------------------------------------------------
		// registra il linguaggio attivo al momento della transazione
		// ----------------------------------------------------------------
		$user_id = $_orderData->virtuemart_user_id;
		if($user_id == 0) return; // abort se l'utente non e' registrato
		$lang = JFactory::getLanguage();
		/* insert user active language */
		$db = JFactory::getDBO();
		$q = "SELECT virtuemart_user_id FROM #__virtuemart_rewardspoints_userlang WHERE virtuemart_user_id=".$user_id;
		$db->setQuery($q);
		$checkuser = $db->loadResult();
		if($checkuser) {
			// UPDATE #__virtuemart_rewardspoints_userlang SET  language =  'it-It' WHERE  virtuemart_user_id=43;
			$q = "UPDATE #__virtuemart_rewardspoints_userlang SET  language =  '".$lang->getTag()."' WHERE  virtuemart_user_id=".$user_id;
		} else {
			$q = "INSERT INTO #__virtuemart_rewardspoints_userlang (`virtuemart_user_id`, `language`) VALUES (".$user_id.", '".$lang->getTag()."'); ";
			$db->setQuery($q);
			$result = $db->execute();	
		}		
		return true;
	}
	
	
	
	
	
	// fired al termine della funzione di cambio stato ordine
	function plgVmOnUpdateOrderPayment($data,$oldStatus) { 
		
		JPlugin::loadLanguage( 'plg_system_rewardpointsvm' );
		$app = JFactory::getApplication();
		$newStatus = $data->order_status;
		// carica configurazione virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		$user_id = $data->virtuemart_user_id; // CONTROLLA CHE L'UTENTE SIA REGISTRATO!
		if($user_id == 0) return; 
		$vrpid = RewardHelper::getAnyUserReferreID( $user_id ); // find user in VRP
			
			
		// seleziona la tipologia di stato in cui avviene l'azione
		$targetEvent = $config['status'];
		$targetEventRestore = $config['restorestatus'];
		// setup default order status if errors
		if(! $targetEvent) $targetEvent = "C";
		if(! $targetEventRestore) $targetEventRestore = "X";
			
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		// REFUND POINTS - ritorna i punti in caso di cancellazione o di ritorno a P da C,U,S
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------

		if($newStatus == $targetEventRestore && $oldStatus != $targetEventRestore){
			// ------------------------------------------------------------------------
			// restoring previous points
			// ------------------------------------------------------------------------
			$db = JFactory::getDBO();
			// controlla che l'ordine non sia stato pagato con creditpoints
			// ----------------------------------------------------------------------
			$q = "SELECT virtuemart_paymentmethod_id FROM #__virtuemart_paymentmethods WHERE "; // trova il custom field creditpoints ::VM3.x
			$q .= "payment_element='creditpoints' ";
			$db->setQuery($q);
			$creditPointsPaymentId = $db->loadResult();
			if($creditPointsPaymentId == $data->virtuemart_paymentmethod_id) return; // demanda tutto al plugin NEL CASO DI REFUND 			
			// trova gli accrediti punti degli ordini nella table rewardpoints refund
			$backuporder = RewardHelper::getSetOrderPointsBackup($data->virtuemart_order_id,$vrpid);
			if($backuporder){				
				$targetPoints = $backuporder->points;
				$aup_information = JText::_('VMRP_RESTORE_ORDER_POINTS' )." ".$backuporder->order_number; // store info
				// data di inserimento tracking
				if($config['validity'] > 0){
					$_dtArray = getdate();
					$_dtArray['mday'] += $config['validity'];			
					$validity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
					$validity = date('Y-m-d G-i-s', $validity );		
				}
				if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,'order '.$backuporder->order_number,$aup_information,-$targetPoints,$validity ); 
				if ($app->isAdmin()) JError::raiseNotice(100, $backuporder->points." points deleted for order ".$backuporder->order_number." to user ".$data->virtuemart_user_id);
				// ripristina il codice coupon di vm che al momento risulta attiva nell'ordine
				// ----------------------------------------------------------------------
				$q = "SELECT * FROM #__virtuemart_orders WHERE virtuemart_order_id=".$data->virtuemart_order_id."; ";
				$db->setQuery($q);
				$orderdata = $db->loadAssoc();
				if($orderdata['coupon_code']){
					$q = "UPDATE #__virtuemart_coupons SET coupon_used = '' WHERE coupon_code = '".$orderdata['coupon_code']."'; ";
					$db->setQuery($q);
					$result = $db->execute();
				}
			}
		}
		
		
		

		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------
		// EARN POINTS - esegui rewardpoints in caso di status
		// ----------------------------------------------------------------------
		// ----------------------------------------------------------------------		
		if($newStatus == $targetEvent && $oldStatus != $targetEvent){
			// setta valori di default per configurazione in caso di dati mancanti
			// ----------------------------------------------------------------------
			// sezione creditpoints
			if(!isset($config['credit_system_hide_credit'])) $config['credit_system_hide_credit'] = "show";
			if(!isset($config['credit_system_hide_other'])) $config['credit_system_hide_other'] = "show";
			if(!isset($config['credit_exclude_reward'])) $config['credit_exclude_reward'] = "exclude";
			if(!isset($config['credit_keep_bonus'])) $config['credit_keep_bonus'] = "discart";
			if(!isset($config['creditValidity'])) $config['creditValidity'] = 0;
			if(!isset($config['buy_credit_exclude_reward'])) $config['buy_credit_exclude_reward'] = "exclude";
			if(!isset($config['buy_credit_keep_bonus'])) $config['buy_credit_keep_bonus'] = "discart";
			if(!isset($config['credit_admin_notification'])) $config['credit_admin_notification'] = 0;
			if(!isset($config['credit_email_type'])) $config['credit_email_type'] = "html";
		    if(!isset($config['refound_coupon_cart_surplus'])) $config['refound_coupon_cart_surplus'] = false;
			// ----------------------------------------------------------------------
			
			$orderId = $data->virtuemart_order_id; 
			$order_number = $data->order_number;
			$user_id = $data->virtuemart_user_id;
			$totalCreditPoints = 0;
			$totalEarnedPoints = 0;
			$totalEarnedReceipt = array();
			$db = JFactory::getDBO();
			$abort = false;	// usato al posto di return perche elimina solo i calcoli non il resto delle funzioni	
			
			// controllo ratio
			$point_ratio =  $config['pointsratio'];
			$point_ratio2 =  $config['pointsratio2'];
			$point_ratio2threshold = '';
			if($point_ratio2) $point_ratio2threshold = $config['pointsratio2threshold'];
			$point_ratio3 =  $config['pointsratio3'];
			$point_ratio3threshold = '';
			if($point_ratio3) $point_ratio3threshold = $config['pointsratio3threshold'];
			$point_ratio4 =  $config['pointsratio4'];
			$point_ratio4threshold = '';
			if($point_ratio4) $point_ratio4threshold = $config['pointsratio4threshold'];
			$point_ratio5 =  $config['pointsratio5'];
			$point_ratio5threshold = '';
			if($point_ratio5) $point_ratio5threshold = $config['pointsratio5threshold'];
			// controllo bonus opzionali per fixed bonus
			$fixedBonusPoints = $config['fixedpointbonus'];
			$fixedpointbonusthreshold2 = $config['fixedpointbonusthreshold2'];
			$fixedBonusPoints2 = $config['fixedBonusPoints2'];
			$fixedpointbonusthreshold3 = $config['fixedpointbonusthreshold3'];
			$fixedBonusPoints3 = $config['fixedBonusPoints3'];
			$fixedpointbonusthreshold4 = $config['fixedpointbonusthreshold4'];
			$fixedBonusPoints4 = $config['fixedBonusPoints4'];
			$fixedpointbonusthreshold5 = $config['fixedpointbonusthreshold5'];
			$fixedBonusPoints5 = $config['fixedBonusPoints5'];
			
			
			
			
			
			
			
			
			
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// cerca se esiste gia' transazione su table refund, in qual caso riaccreditala
			// questo avviene in caso di refunding gia' eseguito e si torni in confirmed
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			$q = "SELECT virtuemart_paymentmethod_id FROM #__virtuemart_paymentmethods WHERE "; // trova il custom field creditpoints ::VM3.x
			$q .= "payment_element='creditpoints' ";
			$db->setQuery($q);
			$creditPointsPaymentId = $db->loadResult();
			// controlla che l'ordine non sia stato pagato con creditpoints nel qual caso demanda al plugin 
			// perche' li viene controllato il suo ratio di cambio con il totale
			if($creditPointsPaymentId != $data->virtuemart_paymentmethod_id) { // demanda tutto al plugin creditpoints 	
				$backuporder = RewardHelper::getSetOrderPointsBackup($data->virtuemart_order_id,$vrpid);
				if($backuporder){
					// riaccredita punti
					if($config['validity'] > 0){
						$_dtArray = getdate();
						$_dtArray['mday'] += $config['validity'];			
						$validity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
						$validity = date('Y-m-d G-i-s', $validity );		
					}
					$aup_information = JText::_('VMRP_RESTORE_ORDER_POINTS' )." ".$backuporder->virtuemart_order_id; // store info
					if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$backuporder->virtuemart_order_id,$aup_information,$backuporder->points,$validity ); 
					if ($app->isAdmin()) JError::raiseNotice(100, $backuporder->points." points restored for order ".$backuporder->order_number." to user ".$data->virtuemart_user_id);
					$abort = true;
				}
			}
			
			
			

			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// trova gli items della transazione
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			$q = "SELECT * FROM #__virtuemart_order_items WHERE ";
			$q .= "virtuemart_order_id='".$orderId."' ";
			$db->setQuery($q);
			$items = $db->loadAssocList();
			
			
			
			
			
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// CREDITPOINTS acquisto crediti
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			if(!$abort){ // solo se non e' gia' stata eseguita dal refund
				// controlla se il prodotto ha dei credit point ed esegue acquisto punti
				$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE "; // trova il custom field creditpoints ::VM3.x
				$q .= "custom_element='vmcreditpoints' ";
				$db->setQuery($q);
				$creditPointsFieldId = $db->loadResult();				
				$targetCreditPoints = 0;
				foreach ($items as $orderitem){ // esegue prima scansione degli items in ordine
					$creditpoints = "";
					if($creditPointsFieldId) {
						$q = "SELECT customfield_value FROM #__virtuemart_product_customfields WHERE ";
						$q .= "virtuemart_product_id=".$orderitem["virtuemart_product_id"]." AND ";
						$q .= "virtuemart_custom_id=".$creditPointsFieldId." ";
						$db->setQuery($q);
						$creditpoints = $db->loadResult();
					}
					if($creditpoints) {
						$targetCreditPoints += $creditpoints*$orderitem['product_quantity'];
					}
				}
				if($targetCreditPoints > 0){
					// expiring per i crediti
					$creditValidity = null;
					if($config['credit_validity'] > 0){
						$_dtArray = getdate();
						$_dtArray['mday'] += $config['credit_validity'];			
						$creditValidity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
						$creditValidity = date('Y-m-d G-i-s', $creditValidity );		
					}
					$aup_information =  JText::_('VMRP_BUY_CREDITS' )." ".$order_number; // store info
					if ($vrpid) RewardHelper::newPoints( 'plgaup_vmcreditpoints',$vrpid,$order_number,$aup_information,$targetCreditPoints,$creditValidity ); 		
					if ($app->isAdmin()) JError::raiseNotice(100, $targetCreditPoints." new credit points from order ".$data->order_number." to user ".$data->virtuemart_user_id);
					//
					$totalCreditPoints = $targetCreditPoints;
					array_push($totalEarnedReceipt,$aup_information);
					// prosegui per eventuale calcolo punti bonus
				}
			}
			
			
			
			
			
			
			

			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// Condizioni aggiuntive di abort calcolo e inserimento in refund table
			// ----------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// controlla che l'ordine non sia stato pagato con creditpoints
			$q = "SELECT virtuemart_paymentmethod_id FROM #__virtuemart_paymentmethods WHERE "; // trova il custom field creditpoints ::VM3.x
			$q .= "payment_element='creditpoints' ";
			$db->setQuery($q);
			$creditPointsPaymentId = $db->loadResult();
			if($creditPointsPaymentId>0){
				if($config['credit_exclude_reward'] == "exclude" && $config['credit_keep_bonus'] == "discart" && $data->virtuemart_paymentmethod_id == $creditPointsPaymentId) {
					$abort=true;	
				}
			}
			// abort in caso la tipologia di pagamento sia tra quelle bannate
			$bannedpayments = array();
			if($config['bannedpayment']){
				$bannedpayments = explode(",",$config['bannedpayment']);
				foreach($bannedpayments as $bannedpayment) {
					if($data->virtuemart_paymentmethod_id == $bannedpayment) {
						$abort = true;
						break;
					}
				}
			}	
			// abort in caso di minimo ordine
			if($config['min_order'] > 0 ) {
				if($config['orderpricesource'] == "base" ) {
					if($data->order_subtotal + $data->order_discount + $data->coupon_discount < $config['min_order'] ) {
						$abort = true;
					}
				} else {
					if($data->order_subtotal + $data->order_tax + order_discount + coupon_discount < $config['min_order'] ) {
						$abort = true;
					}
				}
			}
			
			
			
			
			
			
			
			
			
			
			if(!$abort){
				
				// ----------------------------------------------------------------------
				// ----------------------------------------------------------------------
				// Order to points e product custom points calculation
				// ----------------------------------------------------------------------
				// ----------------------------------------------------------------------
				if($targetCreditPoints == 0 || ($targetCreditPoints > 0 && $config['buy_credit_exclude_reward'] == "include") || ($creditPointsPaymentId>0 && $config['credit_exclude_reward'] == "include" && $data->virtuemart_paymentmethod_id == $creditPointsPaymentId ) ){
					
					// registra il totale dell'ordine per i treshold
					if($config['orderpricesource'] == "base" ) {
						$totaleCarrello = $data->order_subtotal + $data->order_discount + $data->coupon_discount;
					} else {
						$totaleCarrello = $data->order_subtotal + $data->order_tax + $data->order_discount + $data->coupon_discount;
					}
		
					// trova il custom field rewardspoints ::VM3.x
					$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE ";
					$q .= "custom_element='rewardpointsvm' ";
					$db->setQuery($q);
					$customPointsFieldId = $db->loadResult();
					
					//	settaggio variabili
					$targetOrdine = 0;
					$targetCustomPoints = 0;
					
					// analizza tutti gli elementi dell'ordine				
					foreach ($items as $orderitem){
						// ----------------------------------------------------------------------
						// controlla se il prodotto ha dei custom points
						// ---------------------------------------------------------------------- 
						$customPoints = "";
						if($customPointsFieldId) {
							$q = "SELECT customfield_value FROM #__virtuemart_product_customfields WHERE ";
							$q .= "virtuemart_product_id='".$orderitem["virtuemart_product_id"]."' AND ";
							$q .= "virtuemart_custom_id='".$customPointsFieldId."' ";
							$db->setQuery($q);
							$customPoints = $db->loadResult();
						}
						// calcolo dei punti con metono NORMALE
						if($config['custompointstype']=="normal" || $config['custompointstype']=="noratio") {
							if(isset($customPoints)) {
								if($orderitem['product_subtotal_discount'] == 0 || $config['excludediscountcustom']=="include") {
									$targetCustomPoints += $customPoints*$orderitem['product_quantity'];
								}
							} else {
								if($orderitem['product_subtotal_discount'] == 0 || $config['excludediscountamount']=="include") {
									if($config['orderpricesource'] == "base" ) {
										$targetOrdine += $orderitem['product_discountedPriceWithoutTax'] * $orderitem['product_quantity']; // iva esclusa
									} else {
										$targetOrdine += $orderitem['product_final_price'] * $orderitem['product_quantity']; // iva inclusa
									}
								}
							}
						}
						// calcolo dei punti con metono BONUS
						if($config['custompointstype']=="bonus" || $config['custompointstype']=="nocustom") {
							if(isset($customPoints)) {
								if($orderitem['product_subtotal_discount'] == 0 || $config['excludediscountcustom']=="include") {
									$targetCustomPoints += $customPoints*$orderitem['product_quantity'];
								}
							}
							if($orderitem['product_subtotal_discount'] == 0 || $config['excludediscountamount']=="include") {
								if($config['orderpricesource'] == "base" ) {
									$targetOrdine += $orderitem['product_discountedPriceWithoutTax'] * $orderitem['product_quantity']; // iva esclusa
								} else {
									$targetOrdine += $orderitem['product_final_price'] * $orderitem['product_quantity']; // iva inclusa
								}
							}
						}
					} 
					// togli dal conto totale dei punti guadagnati sul costo prodotto gli eventuali coupon
					if(!isset($config['excludecustomwithcoupon'])) $config['excludecustomwithcoupon'] = null;
					if($data->coupon_discount<0) {
						//excludecustomwithcoupon
						$targetOrdine += $data->coupon_discount;
						if($targetOrdine <0) $targetOrdine = 0;
						if($config['excludecustomwithcoupon'] == "exclude") $targetCustomPoints = 0;
					}						
					// controlla treshold opzionali
					if($point_ratio2threshold > 0 && $totaleCarrello >= $point_ratio2threshold) $point_ratio = $point_ratio2;
					if($point_ratio3threshold > 0 && $totaleCarrello >= $point_ratio3threshold) $point_ratio = $point_ratio3;
					if($point_ratio4threshold > 0 && $totaleCarrello >= $point_ratio4threshold) $point_ratio = $point_ratio4;
					if($point_ratio5threshold > 0 && $totaleCarrello >= $point_ratio5threshold) $point_ratio = $point_ratio5;
					// esegui calcolo point ratio e somma al totale custompoints
					if($config['custompointstype']=="noratio") {
						$targetPoints = $targetCustomPoints;	
					} else {
						if($config['custompointstype']=="nocustom") {
							$targetPoints = $targetOrdine*$point_ratio;	
						} else {
							$targetPoints = ($targetOrdine*$point_ratio) + $targetCustomPoints;	
						}
					}
					// CONTROLLA MASSIMO PUNTI
					if($config['max_points'] > 0 ) {
						if($targetPoints  > $config['max_points'] ) {
								$targetPoints = $config['max_points'];
						}
					}
					// CONTROLLA EXPIRING VALIDITY PER I PUNTI
					if(!$config['validity']) $config['validity'] = 365;
					if($config['validity'] > 0){
						$_dtArray = getdate();
						$_dtArray['mday'] += $config['validity'];			
						$validity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
						$validity = date('Y-m-d G-i-s', $validity );		
					}
					// CONTROLLA SE ARROTONDARE O MENO
					if($config['rounded'] == "rounded") {
						$targetPoints = floor($targetPoints);
					} else {
						$targetPoints = round($targetPoints,2);
					}
					// INSERIMENTO PUNTI PER ORDINE AMOUNT
					// ---------------------------------------------------------------------
					$aup_information =  JText::_('VMRP_POINTS_FROM_ORDER' )." ".$order_number; // store info
					if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$targetPoints,$validity ); 
					if ($app->isAdmin()) JError::raiseNotice(100, $targetPoints." new reward points from order ".$data->order_number." to user ".$data->virtuemart_user_id);		
					//
					$totalEarnedPoints += $targetPoints;
					array_push($totalEarnedReceipt,$aup_information);
				} 
				// end esclusione reward points product e order
				// ------------------------------------------------------------------------


				

				// ---------------------------------------------------------------------
				// ---------------------------------------------------------------------
				// CALCOLO BONUS
				// condizioni:
				// 1) non ci sono credit points 
				// 2) si acquistano crediti e sono permessi i reward
				// 3) si acquistano crediti ma sono permessi i bonus al di la dei rewards
				// 4) si paga con punti credito, sono esclusi i reward ma sono consentiti i bonus
				// ---------------------------------------------------------------------
				// ---------------------------------------------------------------------
				
				if($targetCreditPoints == 0 || ($targetCreditPoints > 0 && $config['buy_credit_exclude_reward'] != "exclude") || ($targetCreditPoints > 0 && $config['buy_credit_keep_bonus'] != "discart") ||  ($creditPointsPaymentId>0 && $config['credit_keep_bonus'] != "discart" && $data->virtuemart_paymentmethod_id == $creditPointsPaymentId ) ){

					// BONUS FIXED ORDINE
					// ---------------------------------------------------------------------
					if($config['fixedpointbonus'] > 0){
						
						// controlla treshold opzionali
						if($fixedpointbonusthreshold2 && $totaleCarrello >= $fixedpointbonusthreshold2) $fixedBonusPoints = $fixedBonusPoints2;
						if($fixedpointbonusthreshold3 && $totaleCarrello >= $fixedpointbonusthreshold3) $fixedBonusPoints = $fixedBonusPoints3;
						if($fixedpointbonusthreshold4 && $totaleCarrello >= $fixedpointbonusthreshold4) $fixedBonusPoints = $fixedBonusPoints4;
						if($fixedpointbonusthreshold5 && $totaleCarrello >= $fixedpointbonusthreshold5) $fixedBonusPoints = $fixedBonusPoints5;
						
						if($fixedBonusPoints >0){
							$aup_information = JText::_('VMRP_FIXED_POINTS_FROM_ORDER' )." ".$order_number; // store info
							if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$fixedBonusPoints,$validity ); 
							if ($app->isAdmin()) JError::raiseNotice(100, $fixedBonusPoints." new fixed points from order ".$data->order_number." to user ".$data->virtuemart_user_id);	
							//
							$totalEarnedPoints += $fixedBonusPoints;
							array_push($totalEarnedReceipt,$aup_information);
						 }
					}

					// BIRTHDAY BONUS
					// -------------------------------------------------------------------------
					// preleva i dati del compleanno
					if($config['bonusbirthdayfactor'] >= 100) {
						// test minimo ordine
						$checkBirthdayThreshold	= false;
						if($config['bonusbirthdaythreshold'] > 0) {
							if($config['orderpricesource'] == "base") {
								if($totaleCarrello >= $config['bonusbirthdaythreshold']) {
									$checkBirthdayThreshold = true;
								}
							} else {
								if($totaleCarrello >= $config['bonusbirthdaythreshold']) {
									$checkBirthdayThreshold = true;
								}
							}
						} else {
							$checkBirthdayThreshold = true;
						}
						// se il test minimo e' superato, controlla se esistono dati compleanno, se si esegue la funzione
						if($checkBirthdayThreshold) {	
							$db = JFactory::getDBO();
							$q = "SELECT `birthday_points` FROM #__virtuemart_userinfos WHERE virtuemart_user_id=".$user_id."; ";
							$db->setQuery($q);
							$birtday = $db->loadResult();			
							if($birtday){
								// data di confronto
								$dateNow = getdate();
								$dateNow =  mktime($dateNow['hours'], $dateNow['minutes'], $dateNow['seconds'], $dateNow['mon'], $dateNow['mday'], $dateNow['year']);
								$birtdayDateNow = getdate();
								$birtday = explode("-",$birtday);
								$birtday[0] = $birtdayDateNow['year'];
								$birtday = implode("-",$birtday);
								//$dateNow = date('Y-m-d G-i-s', $dateNow );
								$birtday = strtotime(date("Y-m-d", strtotime($birtday)));
								
								if($config['bonusbirthdayvalidity']){
									$birtdayValidity = strtotime(date("Y-m-d", $birtday) . " +".$config['bonusbirthdayvalidity']." days");
								} else {
									$birtdayValidity = strtotime(date("Y-m-d", $birtday) . " +1 days");
								}
								if($dateNow >= $birtday && $dateNow < $birtdayValidity){
									// INSERIRE QUI LA FUNZIONE DI MODIFICA DEL VALORE
									if($totalCreditPoints>0) {
										if($creditPointsPaymentId>0 && $data->virtuemart_paymentmethod_id == $creditPointsPaymentId){ // se si sta pagando con i punti
											$birthdayPoints = (($totalEarnedPoints+$totalCreditPoints)*$config['bonusbirthdayfactor']/100)-($totalEarnedPoints+$totalCreditPoints);
										} else {
											$birthdayPoints = ($totalCreditPoints*$config['bonusbirthdayfactor']/100)-$totalCreditPoints;
										}
									} else {
										$birthdayPoints = ($totalEarnedPoints*$config['bonusbirthdayfactor']/100)-$totalEarnedPoints;
									}
									if($config['rounded'] == "rounded") {
										$birthdayPoints = floor($birthdayPoints);
									} else {
										$birthdayPoints = round($birthdayPoints,2);
									}
									if($birthdayPoints>0){
										$aup_information = JText::_('VMRP_BIRTHDAY_BONUS_POINTS' )." ".$order_number; // store info
										if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$birthdayPoints,$validity ); 	
										if ($app->isAdmin()) JError::raiseNotice(100, $birthdayPoints." new birthday points from order ".$data->order_number." to user ".$data->virtuemart_user_id);		
										//
										$totalEarnedPoints += $birthdayPoints;
										array_push($totalEarnedReceipt,$aup_information);
									}
								}
							}
						}			
					}

					// PROMOTIONAL PERIODS
					// -------------------------------------------------------------------------
					for($scan=1; $scan <=4; $scan++){
						// preleva i dati del compleanno
						if($config['bonusperiodfactor'.$scan] >100) {
							// test minimo ordine
							$checkPeriodThreshold = false;
							if($config['bonusperiodthreshold'.$scan] > 0) {
								if($config['orderpricesource'] == "base") {
									if($totaleCarrello  >= $config['bonusperiodthreshold'.$scan]) {
										$checkPeriodThreshold = true;
									}
								} else {
									if($totaleCarrello  >= $config['bonusperiodthreshold'.$scan]) {
										$checkPeriodThreshold = true;
									}
								}
							} else {
								$checkPeriodThreshold = true;
							}
							// se il test minimo e' superato, controlla se esistono dati compleanno, se si esegue la funzione
							if($checkPeriodThreshold) {	
								$periodStart = $config['bonusperioddatefrom'.$scan];	
								$periodEnd = $config['bonusperioddateto'.$scan];	
								if($periodStart && $periodEnd){
									// data di confronto
									$dateNow = getdate();
									$dateNow =  mktime($dateNow['hours'], $dateNow['minutes'], $dateNow['seconds'], $dateNow['mon'], $dateNow['mday'], $dateNow['year']);
									//$dateNow = date('Y-m-d G-i-s', $dateNow );
									$periodStart = strtotime(date("Y-m-d", strtotime($periodStart)));
									$periodEnd = strtotime(date("Y-m-d", strtotime($periodEnd)));
									// test excluding date
									$checkExcludingDays = true;
									$excludingDays = array("mon", "tue", "wed", "thu", "fri", "sat", "sun");
									foreach($excludingDays as $day){
										
										if(!isset($config['filterday_'.$day.$scan])) $config['filterday_'.$day.$scan] = null;
										
										if ( strtolower(date('D', $dateNow )) == strtolower($config['filterday_'.$day.$scan]) ){
											$checkExcludingDays=false;
										}
									}
									if($checkExcludingDays && $dateNow >= $periodStart && $dateNow < $periodEnd){
										// INSERIRE QUI LA FUNZIONE DI MODIFICA DEL VALORE
										if($totalCreditPoints>0) {
											if($creditPointsPaymentId>0 && $data->virtuemart_paymentmethod_id == $creditPointsPaymentId){ // se si sta pagando con i punti
												$periodPoints = (($totalEarnedPoints+$totalCreditPoints)*$config['bonusperiodfactor'.$scan]/100)-($totalEarnedPoints+$totalCreditPoints);
											} else {
												$periodPoints = ($totalCreditPoints*$config['bonusperiodfactor'.$scan]/100)-$totalCreditPoints;
											}
										} else {
											$periodPoints = ($totalEarnedPoints*$config['bonusperiodfactor'.$scan]/100)-$totalEarnedPoints;
										}
										if($config['rounded'] == "rounded") {
											$periodPoints = floor($periodPoints);
										} else {
											$periodPoints = round($periodPoints,2);
										}
										if($periodPoints>0){
											$aup_information = JText::_('VMRP_PROMOTIONALPERIOD_BONUS_POINTS' )." ".$order_number; // store info
											if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$periodPoints,$validity ); 
											if ($app->isAdmin()) JError::raiseNotice(100, $periodPoints." new special period points bonus from order ".$data->order_number." to user ".$data->virtuemart_user_id);			
											//
											$totalEarnedPoints += $periodPoints;
											array_push($totalEarnedReceipt,$aup_information);
										}
									}
								}
							}			
						}
					}

					// RANDOM POINT RAFFLE BONUS
					// -------------------------------------------------------------------------
					if($config['randompointbonus'] > 0) {
						
						if(! $config['randompointbonusthreshold']) {
							$randomBonusThreshold = 0;
						 } else {
							 $randomBonusThreshold = $config['randompointbonusthreshold'];
						 }
						 
						 if($totaleCarrello >= $randomBonusThreshold){
							$targetRndPoints = rand(0, $config['randompointbonus']);
							$aup_information =  JText::_('VMRP_RND_POINTS_FROM_ORDER' )." ".$order_number; // store info								
							if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$targetRndPoints,$validity ); 
							if ($app->isAdmin()) JError::raiseNotice(100, $targetRndPoints." new raffle  points bonus from order ".$data->order_number." to user ".$data->virtuemart_user_id);
							//
							$totalEarnedPoints += $targetRndPoints;
							array_push($totalEarnedReceipt,$aup_information);
						 }
					}
					
					// BONUS PRIMO ORDINE USER e BONUS NUMERO ORDINI USER
					// ---------------------------------------------------------------------------
					if( ($config['bonususerfirstorder']>0 || $config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0) || ($config['bonususerordernumber'] > 0 && $config['bonususernumberpoints'] > 0) ) {
						// costruisce lista di metodi di pagamento da escludere nella ricerca del database
						$escludingPaymentQuery = '';
						if(count($bannedpayments)>0){
							foreach($bannedpayments as $bannedpayment) {
								$escludingPaymentQuery .= ' AND `virtuemart_paymentmethod_id`!='.$bannedpayment;
							}
						}					
						// cerca nel database gli ordini dell'utente
						$db = JFactory::getDBO();
						$q = 'SELECT COUNT(*) FROM `#__virtuemart_orders` WHERE `virtuemart_user_id`='.$user_id.' AND (`order_status`= "C" OR `order_status` = "S") '.$escludingPaymentQuery;
						$q.= ' ORDER BY `virtuemart_order_id` ' ;
						$db->setQuery($q);
						$userCountOrders = $db->loadResult();
						if(!$userCountOrders) $userCountOrders =0;
						// ----------------------------------------
						// PRIMO ORDINE USER
						if($config['bonususerfirstorder']>0 || $config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0){
							if( $userCountOrders == 1){
								//
								$bonusFirstOrderPoints = $config['bonususerfirstorder'];
								if($config['bonususerfirstorder_rndmin']>0 || $config['bonususerfirstorder_rndmax']>0){
									if(! $config['bonususerfirstorder_rndmin']) $config['bonususerfirstorder_rndmin'] = 0;
									// se non esiste rndmax o e' maggiore del rndmin lo setta a rndmin
									if(! $config['bonususerfirstorder_rndmax'] || $config['bonususerfirstorder_rndmax']<$config['bonususerfirstorder_rndmin']) { 
										$config['bonususerfirstorder_rndmax'] = $config['bonususerfirstorder_rndmin'] ;
									}
									$bonusFirstOrderPoints += rand($config['bonususerfirstorder_rndmin'], $config['bonususerfirstorder_rndmax']);
								}
								//
								if($bonusFirstOrderPoints>0){
									$aup_information = JText::_('VMRP_USER_FIRST_ORDER_POINTS' );
									if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$bonusFirstOrderPoints,$validity );									if ($app->isAdmin()) JError::raiseNotice(100, $bonusFirstOrderPoints." new points bonus user first order from order ".$data->order_number." to user ".$data->virtuemart_user_id);
									$totalEarnedPoints += $bonusFirstOrderPoints;
									array_push($totalEarnedReceipt,$aup_information);
								}
							}
						}

						// NUMERO ORDINI USER
						if($config['bonususerordernumber'] > 0 && $config['bonususernumberpoints'] > 0){
							if( $userCountOrders % $config['bonususerordernumber'] == 0 ) {
								//
								$aup_information = JText::_('VMRP_USER_ORDER_POINTS' )." ".$userCountOrders." orders"; // store info
								if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$config['bonususernumberpoints'],$validity ); 
								if ($app->isAdmin()) JError::raiseNotice(100, $bonusFirstOrderPoints." new points bonus user orders quantity from order ".$data->order_number." to user ".$data->virtuemart_user_id);
								//
								$totalEarnedPoints += $config['bonususernumberpoints'];
								array_push($totalEarnedReceipt,$aup_information);
							}
						}
					}
				
					// BONUS NUMERO ORDINI GLOBALE
					// ---------------------------------------------------------------------			
					if( $config['bonusordernumber'] > 0 && $config['bonusordernumberpoints'] > 0 ) {
						// costruisce lista di metodi di pagamento da escludere nella ricerca del database
						$escludingPaymentQuery = '';
						if(count($bannedpayments)>0){
							foreach($bannedpayments as $bannedpayment) {
								$escludingPaymentQuery .= ' AND `virtuemart_paymentmethod_id`!='.$bannedpayment;
							}
						}					
						// cerca nel database gli ordini dell'utente
						$db = JFactory::getDBO();
						$q = 'SELECT COUNT(*) FROM `#__virtuemart_orders` WHERE (`order_status`= "C" OR `order_status` = "S") '.$escludingPaymentQuery;
						$q.= ' ORDER BY `virtuemart_order_id` ' ;
						$db->setQuery($q);
						$countOrders = $db->loadResult();
						if( $countOrders % $config['bonusordernumber'] == 0 ) {
							$aup_information = JText::_('VMRP_SHOP_ORDER_POINTS' )." ".$countOrders; // store info
							if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$config['bonusordernumberpoints'],$validity ); 
							if ($app->isAdmin()) JError::raiseNotice(100, $bonusFirstOrderPoints." new points bonus user shop orders quantity from order ".$data->order_number." to user ".$data->virtuemart_user_id);
							//
							$totalEarnedPoints += $config['bonusordernumberpoints'];
							array_push($totalEarnedReceipt,$aup_information);
						}
					}
				}
				// end esclusione bonus in caso di credit points ed impostazioni discart
				// ------------------------------------------------------------------------
				
			} // END MASTER ABORT
			
			
			
			
			// ---------------------------------------------------------------------	
			// ---------------------------------------------------------------------
			// INVIO EMAIL PER CREDIT POINTS
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			if($totalCreditPoints >0){
				// controlla il linguaggio attivo dell'utente registrato all'acquisto
				$q = "SELECT `language` FROM #__virtuemart_rewardspoints_userlang WHERE `virtuemart_user_id` = ".$user_id;
				$db->setQuery($q);
				$language = $db->loadResult();
				if(! $language) {
					$lang = JFactory::getLanguage();
					$language = $lang->getTag();
				}
				// controlla se nel settaggio e' selezionato di inviare un email per questa lingua altrimenti NON invia
				if($config['credit_email_message_'.$language]) {
					// trova l'utente registrato in joomla (in quanto deve essere registrato in joomla non in vm per funzionare)
					$q = "SELECT * FROM #__users WHERE `id` = ".$user_id;
					$db->setQuery($q);
					$userinfo = $db->loadAssoc();
					// trova il punteggio total						
					if ($vrpid) $newtotalpoints = RewardHelper::getCurrentTotalPoints($vrpid);
					/*
					content id = $config['email_message_'.$language];
					content type = $config['email_type'];
					*/
					$contentParams = array(
						array( "{username}", $userinfo['username'] ),
						array( "{name}", $userinfo['name'] ),
						array( "{order}", $order_number ),
						array( "{credits}", $totalCreditPoints ),
						array( "{newtotal}", $newtotalpoints )
					);
					//
					RewardHelper::rewardMail($userinfo['email'],$config['email_message_'.$language], $contentParams, $config['email_type'], $config['credit_admin_notification']);
				}					
			}
			
			
			
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			// INVIO EMAIL PER REWARD POINTS
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			if($totalEarnedPoints>0){
				// controlla il linguaggio attivo dell'utente registrato all'acquisto
				$q = "SELECT `language` FROM #__virtuemart_rewardspoints_userlang WHERE `virtuemart_user_id` = ".$user_id;
				$db->setQuery($q);
				$language = $db->loadResult();
				if(! $language) {
					$lang = JFactory::getLanguage();
					$language = $lang->getTag();
				}
				// controlla se nel settaggio e' selezionato di inviare un email per questa lingua altrimenti NON invia
				if($config['email_message_'.$language]) {
					// trova l'utente registrato in joomla (in quanto deve essere registrato in joomla non in vm per funzionare)
					$q = "SELECT * FROM #__users WHERE `id` = ".$user_id;
					$db->setQuery($q);
					$userinfo = $db->loadAssoc();
					// trova il punteggio total					
					if ($vrpid) $newtotalpoints = RewardHelper::getCurrentTotalPoints($vrpid);
					/*
					content id = $config['email_message_'.$language];
					content type = $config['email_type'];
					*/
					$contentParams = array(
						array( "{username}", $userinfo['username'] ),
						array( "{name}", $userinfo['name'] ),
						array( "{order}", $order_number ),
						array( "{points}", $totalEarnedPoints ),
						array( "{newtotal}", $newtotalpoints )
					);
					//
					RewardHelper::rewardMail($userinfo['email'],$config['email_message_'.$language], $contentParams, $config['email_type'], $config['admin_notification']);
				}					
			}
			
			
			
			
			
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			// creazione automatica nuovo coupon da order
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			if($totalEarnedPoints>0 && $config['autochips']==1 && $config['autochips_allchips']!=1){ // not usefull in case of autochip_allchip
					
				JLoader::import('joomla.application.component.model');
				JLoader::import( 'pointstocash', JPATH_ROOT .DIRECTORY_SEPARATOR. 'components' .DIRECTORY_SEPARATOR. 'com_rewardpointsvm' .DIRECTORY_SEPARATOR. 'models' );
				$model = JModelLegacy::getInstance( 'pointstocash', 'rewardpointsvmModel' );
				
				$lang = JFactory::getLanguage();
				$lang->load('com_rewardpointsvm', JPATH_SITE, $lang->getTag(), true);		
				$currencysymbol = $config['coupon_currency_symbol'] ;
						
				// -------------------------------------------------------------------------
				$referrerid = RewardHelper::getAnyUserReferreID( $user_id ); // find user in AUP
				$currenttotalpoints = RewardHelper::getCurrentTotalPoints( $referrerid );			
									
				if( $config['coupon_rounded'] == "rounded"){
					$pointsChip = $totalEarnedPoints;
					$newCouponValue =  floor($pointsChip/$config['coupon_unit_points']);
				} else {
					$pointsChip = $totalEarnedPoints;
					$newCouponValue =  round($pointsChip/$config['coupon_unit_points'],2);
				}
				
				// abort in caso di errori - uguale a javascript ma non pu essere hackerata dal brower-editing
				$error = false;
				if($pointsChip < 0) $error =  true;
				if(! $pointsChip || $pointsChip == 0 || ! is_numeric($pointsChip) ) $error =  true;	
				if($minpoints && $pointsChip < $minpoints ) $error =  true;	
				if (! $error ) {
					// data di creazione coupon
					$_dtArray = getdate();
					$newCreationDate =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
					$newExpiryDate = $newCreationDate;
					if($config['awoexpiring'] >0)	{
						$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +".$config['awoexpiring']." days");
					} else {
						$newExpiryDate = strtotime(date("Y-m-d", $newExpiryDate) . " +365 days");
					}
					// formatta per mySql le date php
					$newCreationDate = date('Y-m-d G-i-s', $newCreationDate );
					$newExpiryDate = date('Y-m-d G-i-s', $newExpiryDate );
					// crea nuovo codice coupon
					
					$codecomplexity = 9;
					if($config['codecomplexity']) $codecomplexity = floor($config['codecomplexity']);
					$newCode = RewardHelper::generate_random_code($codecomplexity);	
							
					// -------------------------------------------------------------------------------
					// Crea coupon, paga con i punti e spedisce email
					// -------------------------------------------------------------------------------
					$newCoupon = $model->_createCoupon($newCode, $newCouponValue, $newCreationDate, $newExpiryDate);
					$code_coupon = $model->_purchase_coupon($user_id, $referrerid, $newCoupon, $pointsChip, $newCouponValue, $newExpiryDate );
				}
			}
			
			// ---------------------------------------------------------------------
			// ----------------------------------------------------------------------
			// opzione ritorna parziale punti coupon eccedenti da ordine
			// ----------------------------------------------------------------------
			// ---------------------------------------------------------------------
			if($config['refound_coupon_cart_surplus']) {
				$billTotal = $data->order_total;
				$billSubtotal = $data->order_subtotal;
				$billSubtotalTax = $data->order_tax;
				// se il coupon del conto era superiore al conto stesso
				if( abs($data->coupon_discount)>$billSubtotal+$billSubtotalTax && $billTotal == 0 ) {
					// controlla che il coupon sia stato generato da rewardpoints
					$db = JFactory::getDBO();
					$query = "";
					$query.="SELECT virtuemart_user_id FROM #__virtuemart_rewardspoints_details, #__virtuemart_rewardspoints ";
					$query.="WHERE #__virtuemart_rewardspoints_details.keyreference='".$data->coupon_code."' ";
					$query.="AND #__virtuemart_rewardspoints_details.referreid = #__virtuemart_rewardspoints.referreid ";
					$db->setQuery($query);
					$ref = $db->loadResult();
															
					// se il codice coupon inserito corrisponde ad una chip creata da reward points 
					if( $ref == $user_id ) {
						// valore = punti / ratio ----- punti = valore * ratio
						$restoringPartialPoints = (abs($data->coupon_discount) - round(($billSubtotal+$billSubtotalTax),2) )*$config['coupon_unit_points'] ; 
						// ---------------------------------------------------------------------
						// INSERIMENTO PUNTI PER ORDINE AMOUNT
						// ---------------------------------------------------------------------
						if($config['validity'] > 0){
							$_dtArray = getdate();
							$_dtArray['mday'] += $config['validity'];			
							$validity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
							$validity = date('Y-m-d G-i-s', $validity );		
						}
						$aup_information = JText::_('VMRP_RESTORE_ORDER_POINTS' )." ".$order_number; // store info
						if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid,$order_number,$aup_information,$restoringPartialPoints,$validity ); 		
					}
				}
			}
			
			// ---------------------------------------------------------------------
			// ---------------------------------------------------------------------
			// inserimento totale punti transazione (ordine+bonus+crediti) in __virtuemart_rewardspoints_refund 
			if($totalEarnedPoints>0 || $totalCreditPoints>0 ){
				// avviene solo quando non trova gia' altre linee
				$backuporder = RewardHelper::getSetOrderPointsBackup($data->virtuemart_order_id, $vrpid, $totalEarnedPoints+$totalCreditPoints, $data->order_number);
			}
			
		} // if($newStatus == $targetEvent)
		
		
		return true;
	}



// END CLASS	
}