<?php
/*
 * @component Virtuemart Reward Points
 * @copyright Copyright (C) 2012 Marco Coan
 * @license : GNU/GPL
 * @Website : http://www.virtuemartrewardpoints.com
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgUserRewardpointsvm_newuser extends JPlugin {

	
	function onUserAfterDelete($user, $success, $msg) {
		if (!$success) return false;
		$userid = JArrayHelper::getValue($user, 'id', 0, 'int');
		if ($userid>0){
			$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
			require_once ($api_VRP);
			$vrpid = RewardHelper::getAnyUserReferreID($userid); 	
			if($vrpid){
				// cancella utente dalla lista reward
				$db = JFactory::getDBO();
				$query = "DELETE FROM #__virtuemart_rewardspoints WHERE `virtuemart_user_id`=".$userid;
				$db->setQuery( $query );
				$db->execute();
				// cancella utente dalla lista reward details
				$query = "DELETE FROM #__virtuemart_rewardspoints_details WHERE `referreid`='".$vrpid."' ";
				$db->setQuery( $query );
				$db->execute();
			}
		}
		return true;
	}
	
	
	
	public function onUserAfterSave($user, $isnew, $success, $msg)    {		
		if ($isnew) {
			// carica configurazione virtuemart reward points --------------------------------
			$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
			require_once ($api_VRP);
			$config = RewardHelper::getSettings(); 
			// trova l'id dell'utente registrato
			$userid = JArrayHelper::getValue($user, 'id', 0, 'int');
			$userinfo = JFactory::getUser( $userid );
			
			if ($config['bonususernewregistration']>0) {
				
				// controlla il linguaggio attivo dell'utente registrato all'acquisto
				$db = JFactory::getDBO();
				$q = "SELECT `language` FROM #__virtuemart_rewardspoints_userlang WHERE `virtuemart_user_id` = ". $userinfo->id;
				$db->setQuery($q);
				$language = $db->loadResult();
				if(! $language) {
					$lang = JFactory::getLanguage();
					$language = $lang->getTag();
				}
				
				// carica linguaggio virtuemart file orders
				$extension = 'plg_system_rewardpointsvm';
				$base_dir = JPATH_ADMINISTRATOR;
				$reload = true;
				$lang->load($extension, $base_dir, $language, $reload);
								
				// controlla expiring date per i punti
				if($config['validity'] > 0){
					$_dtArray = getdate();
					$_dtArray['mday'] += $config['validity'];			
					$validity =  mktime($_dtArray['hours'], $_dtArray['minutes'], $_dtArray['seconds'], $_dtArray['mon'], $_dtArray['mday'], $_dtArray['year']);
					$validity = date('Y-m-d G-i-s', $validity );		
				}
				$plg_information = JText::_('VMRP_USER_NEW_REGISTRATION' );
				// assegna nuovi punti al nuovo utente (solo rewardpoints, aup ha il suo plugin)			
				$vrpid = RewardHelper::getAnyUserReferreID( $userinfo->id ); // find user in VRP
				if ($vrpid) RewardHelper::newPoints( 'plgaup_vmalpharewardspoints',$vrpid, $userinfo->username, $plg_information,$config['bonususernewregistration'],$validity ); 
				
				// ---------------------------------------------------------------------
				// INVIO EMAIL PER REWARD POINTS
				// ---------------------------------------------------------------------
				// controlla se nel settaggio e' selezionato di inviare un email per questa lingua altrimenti NON invia
				if($config['email_message_'.$language]) {
					// controlla se esiste aup per sapere da dove prendere il totla punti
					$vrpid = RewardHelper::getAnyUserReferreID( $userinfo->id ); 
					if ($vrpid) $newtotalpoints = RewardHelper::getCurrentTotalPoints($vrpid);								
					/*
					content id = $config['email_message_'.$language];
					content type = $config['email_type'];
					*/

					$contentParams = array(
						array( "{username}", $userinfo->username ),
						array( "{name}", $userinfo->name ),
						array( "{order}", JText::_('VMRP_USER_NEW_REGISTRATION' ) ),
						array( "{points}", $config['bonususernewregistration'] ),
						array( "{newtotal}", $newtotalpoints )
					);
					//
					RewardHelper::rewardMail($userinfo->email,$config['email_message_'.$language], $contentParams, $config['email_type'], $config['admin_notification']);
				}	
			}
		}
		return $success;
	}
	
	
}
?>